package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.AlcadaDao;
import br.com.centralit.api.model.Alcada;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Sort;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 23/06/2015 - 11:20:28
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Repository("alcadaDao")
public class AlcadaDaoHibernate extends CitGenericDAOImpl implements AlcadaDao {
	public AlcadaDaoHibernate() {
		super(Alcada.class);
	}

	@Override
	public Collection<Alcada> listarAlcadas(String nome) {

		// TODO Auto-generated method stub
		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterILike("nome", "%" + nome + "%");

    	search.addFilterEmpty("dataInativo");

		search.addSort(Sort.asc("nome"));

		search.setMaxResults(10);
		
		return this.search(search, this.persistentClass);
	}

	@Override
	public Alcada findByIdentificador(String identificador) {
		SearchSeven search = new SearchSeven();

		search.addFilterEqual("identificador", identificador);

		search.addFilterEmpty("dataInativo");

		search.setMaxResults(1);

		return this.searchUnique(search, Alcada.class);
	}

	@Override
	public boolean existeAlcadaVinculadaAoNivelAutoridade(long idNivelAutoridade) {
		// TODO Auto-generated method stub
		SearchSeven search = new SearchSeven();

		search.addFilterIn("niveisAutoridades.nivelAutoridade.id", idNivelAutoridade);

		search.addFilterEmpty("niveisAutoridades.dataInativo");

		return this.count(search) > 0 ? Boolean.TRUE : Boolean.FALSE;
	}
}
