package br.com.centralit.api.dao.impl;

import java.util.List;

import br.com.centralit.api.model.CentroCusto;
import br.com.centralit.api.dao.CentroCustoDao;

import org.springframework.stereotype.Repository;

import com.googlecode.genericdao.search.Filter;
import com.googlecode.genericdao.search.Sort;

import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.util.UtilObjeto;

@Repository("centroCustoDao")
public class CentroCustoDaoHibernate extends CitGenericDAOImpl implements CentroCustoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param classs
	 */
	public CentroCustoDaoHibernate() {

		super(CentroCusto.class);

	}

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por listar centros de custo por organizacao do usuario logado
	 *
	 * @author iago.almeida
	 *
	 * @param codigo
	 * @param idOrganizacao
	 * @param idCentroCusto
	 * @return List<CentroCusto>
	 */
	@Override
	public List<CentroCusto> findAutoCompleteCentroCustoByOrganizacao(String value, Long idOrganizacao, Long idCentroCusto) {

		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterOr(Filter.ilike("codigo", "%" + value + "%"), Filter.ilike("descricao", "%" + value + "%"));

		search.addFilterEqual("organizacao.id", idOrganizacao);

		if(UtilObjeto.isReferencia(idCentroCusto)){
			search.addFilterNotEqual("id", idCentroCusto);
		}
		
		search.addSort(Sort.asc("descricao"));

		search.setMaxResults(10);

		return this.search(search, this.persistentClass);

	}
}
