package br.com.centralit.api.dao.impl;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.CentroResultadoDao;
import br.com.centralit.api.model.CentroResultado;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/06/2015 - 14:09:34
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Repository("centroResultadoDao")
public class CentroResultadoDaoHibernate extends CitGenericDAOImpl implements CentroResultadoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param classs
	 */
	public CentroResultadoDaoHibernate() {

		super(CentroResultado.class);

	}

	@Override
	public CentroResultado findByCodigo(String codigo) {

		SearchSeven search = new SearchSeven();

		search.addFilterEqual("codigo", codigo);

		search.addFilterEmpty("dataInativo");

		search.setMaxResults(1);

		return this.searchUnique(search, CentroResultado.class);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean nomeIsUnico(String nome) {

		SearchSeven search = new SearchSeven();

		search.addFilterILike("nome", nome);

		return this.count(search) > 0;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean codigoIsUnico(String codigo) {

		SearchSeven search = new SearchSeven();

		search.addFilterILike("codigo", codigo);

		return this.count(search) > 0;
	}

	@Override
	public CentroResultado findByCodigoSistemaOrigem(String codigo) {
		SearchSeven search = new SearchSeven();

		search.addFilterEqual("codigoSistemaOrigem", codigo);

		search.addFilterEmpty("dataInativo");

		search.setMaxResults(1);

		return this.searchUnique(search, CentroResultado.class);
	}

}
