package br.com.centralit.api.dao.impl;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.TerceirizadoDao;
import br.com.centralit.api.model.Terceirizado;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.util.UtilObjeto;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 15/12/2015 - 15:09:46
 *
 * @version 1.0.0
 *
 * @author rogerio.cassimiro
 *	
 */
@Repository("terceirizadoDao")
public class TerceirizadoDaoHibernate extends CitGenericDAOImpl implements TerceirizadoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param classs
	 */
	public TerceirizadoDaoHibernate() {

		super(Terceirizado.class);
	}

	/**
	 * Método responsável por obter permissão para assinatura de documento
	 * @author rogerio.cassimiro
	 * @param idUsuario
	 * @return {@link Boolean}
	 */
	@Override
	public boolean getPermissaoAssinaturaDocumento(Long idUsuario) {
		SearchSeven searchSeven = new SearchSeven();
		searchSeven.addFilterEqual("pessoa.usuario.id", idUsuario);
		searchSeven.addFilterEqual("classeParceiro.dominioTipoParceiro.codigo", Dominio.TIPO_PARCEIRO_TERCEIRIZADO);
		searchSeven.addFilterNotEmpty("funcao.id");
		return UtilObjeto.isReferencia(this.searchUnique(searchSeven));
	}
}
