package br.com.centralit.api.model;

import java.math.BigDecimal;
import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.framework.json.MoneyDeserializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Grupo;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 23/06/2015 - 11:19:48
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Entity
public class Alcada extends PersistentObjectAuditOrganizacao {

    /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo id. */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ Views.GenericView.class, 
    			ViewsTabelasCorp.CentroResultadoEditView.class })
    private Long id;
    
    @JsonView({ Views.GenericView.class, 
    	ViewsTabelasCorp.CentroResultadoEditView.class,
    	ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class,
    	Views.AlcadaEditView.class,
    	ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class})
    private String nome;
    
    @JsonView({ Views.GenericView.class })
    private String identificador;
    
    @JsonView({ Views.GenericView.class, Views.AlcadaEditView.class})
    private String fluxoDelegacao;

    @ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class,
    	ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class,
    	Views.AlcadaEditView.class,
    	ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class})
    private Grupo grupoAdministrador;

	@ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class,
    	ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class,
    	Views.AlcadaEditView.class,
    	ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class})
    private Grupo grupoResponsavel;
    
	@JsonView({ Views.GenericView.class })
    private Boolean permiteAprovacaoNivelInferior;
	
	@JsonView({ Views.GenericView.class })
	private Boolean somenteMenorHierarquia;
    
    @Column(precision = 20, scale = 2)
    @JsonDeserialize(using = MoneyDeserializer.class)
    @JsonView({ Views.GenericView.class })
    private BigDecimal percDispensaNovaAprovacao;
        
    @OneToMany(fetch = FetchType.LAZY, mappedBy = "alcada", cascade = CascadeType.ALL, orphanRemoval = true)
    @JsonView({ Views.GenericView.class })
    private Collection<AlcadaNivelAutoridade> niveisAutoridades;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {
	
		return id;
	}

	
	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id 
	 */
	public void setId(Long id) {
	
		this.id = id;
	}

	
	/**
	 * Retorna o valor do atributo <code>nome</code>
	 *
	 * @return <code>String</code>
	 */
	public String getNome() {
	
		return nome;
	}

	
	/**
	 * Define o valor do atributo <code>nome</code>.
	 *
	 * @param nome 
	 */
	public void setNome(String nome) {
	
		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>identificador</code>
	 *
	 * @return <code>String</code>
	 */
	public String getIdentificador() {
	
		return identificador;
	}

	
	/**
	 * Define o valor do atributo <code>identificador</code>.
	 *
	 * @param identificador 
	 */
	public void setIdentificador(String identificador) {
	
		this.identificador = identificador;
	}

	
	/**
	 * Retorna o valor do atributo <code>grupoAdministrador</code>
	 *
	 * @return <code>Grupo</code>
	 */
	public Grupo getGrupoAdministrador() {
	
		return grupoAdministrador;
	}

	
	/**
	 * Define o valor do atributo <code>grupoAdministrador</code>.
	 *
	 * @param grupoAdministrador 
	 */
	public void setGrupoAdministrador(Grupo grupoAdministrador) {
	
		this.grupoAdministrador = grupoAdministrador;
	}

	
	/**
	 * Retorna o valor do atributo <code>grupoResponsavel</code>
	 *
	 * @return <code>Grupo</code>
	 */
	public Grupo getGrupoResponsavel() {
	
		return grupoResponsavel;
	}

	
	/**
	 * Define o valor do atributo <code>grupoResponsavel</code>.
	 *
	 * @param grupoResponsavel 
	 */
	public void setGrupoResponsavel(Grupo grupoResponsavel) {
	
		this.grupoResponsavel = grupoResponsavel;
	}

	
	/**
	 * Retorna o valor do atributo <code>permiteAprovacaoNivelInferior</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getPermiteAprovacaoNivelInferior() {
	
		return permiteAprovacaoNivelInferior;
	}

	
	/**
	 * Define o valor do atributo <code>permiteAprovacaoNivelInferior</code>.
	 *
	 * @param permiteAprovacaoNivelInferior 
	 */
	public void setPermiteAprovacaoNivelInferior(Boolean permiteAprovacaoNivelInferior) {
	
		this.permiteAprovacaoNivelInferior = permiteAprovacaoNivelInferior;
	}


	/**
	 * Retorna o valor do atributo <code>percDispensaNovaAprovacao</code>
	 *
	 * @return <code>BigDecimal</code>
	 */
	public BigDecimal getPercDispensaNovaAprovacao() {
	
		return percDispensaNovaAprovacao;
	}


	
	/**
	 * Define o valor do atributo <code>percDispensaNovaAprovacao</code>.
	 *
	 * @param percDispensaNovaAprovacao 
	 */
	public void setPercDispensaNovaAprovacao(BigDecimal percDispensaNovaAprovacao) {
	
		this.percDispensaNovaAprovacao = percDispensaNovaAprovacao;
	}


	/**
	 * Retorna o valor do atributo <code>niveisAutoridades</code>
	 *
	 * @return <code>Collection<AlcadaNivelAutoridade></code>
	 */
	public Collection<AlcadaNivelAutoridade> getNiveisAutoridades() {
	
		return niveisAutoridades;
	}

	
	/**
	 * Define o valor do atributo <code>niveisAutoridades</code>.
	 *
	 * @param niveisAutoridades 
	 */
	public void setNiveisAutoridades(Collection<AlcadaNivelAutoridade> niveisAutoridades) {
	
		this.niveisAutoridades = niveisAutoridades;
	}


	
	/**
	 * Retorna o valor do atributo <code>somenteMenorHierarquia</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getSomenteMenorHierarquia() {
	
		return somenteMenorHierarquia;
	}


	
	/**
	 * Define o valor do atributo <code>somenteMenorHierarquia</code>.
	 *
	 * @param somenteMenorHierarquia 
	 */
	public void setSomenteMenorHierarquia(Boolean somenteMenorHierarquia) {
	
		this.somenteMenorHierarquia = somenteMenorHierarquia;
	}


	
	/**
	 * Retorna o valor do atributo <code>fluxoDelegacao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getFluxoDelegacao() {
	
		return fluxoDelegacao;
	}


	
	/**
	 * Define o valor do atributo <code>fluxoDelegacao</code>.
	 *
	 * @param fluxoDelegacao 
	 */
	public void setFluxoDelegacao(String fluxoDelegacao) {
	
		this.fluxoDelegacao = fluxoDelegacao;
	}

}
