package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 23/06/2015 - 11:21:42
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Entity
@JsonIgnoreProperties({ "$index"})
public class AlcadaNivelAutoridade extends PersistentObject {

    /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo id. */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ Views.GenericView.class })
    private Long id;
    
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Alcada alcada;
    
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JsonView({ Views.GenericView.class })
    private NivelAutoridade nivelAutoridade;
    
    @JsonView({ Views.GenericView.class,
    			Views.AlcadaEditView.class })
    private Boolean permiteAprovacaoPropria;
    
    @JsonView({ Views.GenericView.class,
    			Views.AlcadaEditView.class })
    private Boolean permiteSolicitacao;
    
    @JsonView({ Views.GenericView.class,
    			Views.AlcadaEditView.class })
    private Integer antecedenciaMinimaAprovacao;
    
     /**
     * Retorna o valor do atributo <code>alcada</code>
     *
     * @return <code>Alcada</code>
     */
    public Alcada getAlcada() {

        return alcada;
    }

    /**
     * Define o valor do atributo <code>alcada</code>.
     *
     * @param alcada
     */
    public void setAlcada(Alcada alcada) {

        this.alcada = alcada;
    }
     
     /**
     * Retorna o valor do atributo <code>nivelAutoridade</code>
     *
     * @return <code>NivelAutoridade</code>
     */
    public NivelAutoridade getNivelAutoridade() {

        return nivelAutoridade;
    }

    /**
     * Define o valor do atributo <code>nivelAutoridade</code>.
     *
     * @param nivelAutoridade
     */
    public void setNivelAutoridade(NivelAutoridade nivelAutoridade) {

        this.nivelAutoridade = nivelAutoridade;
    }
     
     /**
     * Retorna o valor do atributo <code>permiteAprovacaoPropria</code>
     *
     * @return <code>Boolean</code>
     */
    public Boolean getPermiteAprovacaoPropria() {

        return permiteAprovacaoPropria;
    }

    /**
     * Define o valor do atributo <code>permiteAprovacaoPropria</code>.
     *
     * @param permiteAprovacaoPropria
     */
    public void setPermiteAprovacaoPropria(Boolean permiteAprovacaoPropria) {

        this.permiteAprovacaoPropria = permiteAprovacaoPropria;
    }
     
     /**
     * Retorna o valor do atributo <code>permiteSolicitacao</code>
     *
     * @return <code>Boolean</code>
     */
    public Boolean getPermiteSolicitacao() {

        return permiteSolicitacao;
    }

    /**
     * Define o valor do atributo <code>permiteSolicitacao</code>.
     *
     * @param permiteSolicitacao
     */
    public void setPermiteSolicitacao(Boolean permiteSolicitacao) {

        this.permiteSolicitacao = permiteSolicitacao;
    }
     
     /**
     * Retorna o valor do atributo <code>antecedenciaMinimaAprovacao</code>
     *
     * @return <code>Integer</code>
     */
    public Integer getAntecedenciaMinimaAprovacao() {

        return antecedenciaMinimaAprovacao;
    }

    /**
     * Define o valor do atributo <code>antecedenciaMinimaAprovacao</code>.
     *
     * @param antecedenciaMinimaAprovacao
     */
    public void setAntecedenciaMinimaAprovacao(Integer antecedenciaMinimaAprovacao) {

        this.antecedenciaMinimaAprovacao = antecedenciaMinimaAprovacao;
    }
     
     /**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}
}
