package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 21/05/2015 - 09:49:11
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
@Entity
public class CentroCusto extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -572726028634140678L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class})
	private Long id;

	/** Atributo codigo. */
	@Column(length = 30)
	@JsonView({ //ViewsAlmoxarifado.CentroCustoAutoCompleteView.class, 
				Views.RequisicaoConsumo.class,
				ViewsTabelasCorp.CentroCustoEditView.class,
				Views.EstruturaOrganizacionalAutoCompleteSimplesView.class,
				Views.EstruturaOrganizacionalAlmoxarifadoEditView.class})
	private String codigo;

	/** Atributo descricao. */
	@JsonView({ //ViewsAlmoxarifado.CentroCustoAutoCompleteView.class, 
				Views.RequisicaoConsumo.class,
				ViewsTabelasCorp.CentroCustoEditView.class,
				Views.EstruturaOrganizacionalAutoCompleteSimplesView.class,
				Views.EstruturaOrganizacionalAlmoxarifadoEditView.class})
	private String descricao;

	@JsonView({	ViewsTabelasCorp.CentroCustoEditView.class})
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private CentroCusto centroCustoParent;
	
	/** Atributo codigoDescricao. */
	@Transient
	@JsonView({ Views.RequisicaoConsumo.class,
		ViewsTabelasCorp.CentroCustoEditView.class,
		Views.EstruturaOrganizacionalAlmoxarifadoEditView.class})
	private String codigoDescricao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public CentroCusto() {

		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param codigo
	 * @param descricao
	 * @param centroCustoParent
	 */
	public CentroCusto(String codigo, String descricao, CentroCusto centroCustoParent) {

		this();

		this.codigo = codigo;
		this.descricao = descricao;
		this.centroCustoParent = centroCustoParent;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 *
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}

	/**
	 * Define o valor do atributo <code>codigo</code>.
	 *
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 *
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>centroCustoParent</code>
	 *
	 * @return <code>CentroCusto</code>
	 */
	public CentroCusto getCentroCustoParent() {

		return centroCustoParent;
	}

	/**
	 * Define o valor do atributo <code>centroCustoParent</code>.
	 *
	 * @param centroCustoParent
	 */
	public void setCentroCustoParent(CentroCusto centroCustoParent) {

		this.centroCustoParent = centroCustoParent;
	}
	
	public String getCodigoDescricao() {
		return this.getCodigo().concat(" - ").concat(this.getDescricao());
	}

}
