package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/06/2015 - 14:09:52
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Entity
@DiscriminatorColumn(name = "dtype", discriminatorType = DiscriminatorType.STRING)
@DiscriminatorValue("CENTRO_RESULTADO")
@JsonIgnoreProperties({ "$selected", "$index" })
public class CentroResultado extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -572726028634140678L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	protected Long id;

	/** Atributo codigo. */
	@Column(length = 30)
	@JsonView({ Views.GenericView.class, ViewsTabelasCorp.CentroResultadoEditView.class })
	protected String codigo;

	/** Atributo nome. */
	@JsonView({ Views.GenericView.class, ViewsTabelasCorp.CentroResultadoEditView.class, ViewsTabelasCorp.CentroResultadoAutoCompleteView.class, ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class })
	protected String nome;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class })
	protected CentroResultado centroResultadoParent;

	@Transient
	@JsonView({ Views.GenericView.class })
	protected String codigoParent;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "centroResultado", cascade = CascadeType.ALL)
	@JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class })
	protected Collection<CentroResultadoResponsavel> responsaveis;

	@Column(length = 30)
	@JsonView({ Views.GenericView.class, ViewsTabelasCorp.CentroResultadoEditView.class })
	protected String codigoSistemaOrigem;
	
	@Transient
	@JsonView({ Views.GenericView.class })
	protected Boolean hasParent;
	

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}

	/**
	 * Define o valor do atributo <code>codigo</code>.
	 * 
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>centroResultadoParent</code>
	 * 
	 * @return <code>CentroResultado</code>
	 */
	public CentroResultado getCentroResultadoParent() {

		return centroResultadoParent;
	}

	/**
	 * Define o valor do atributo <code>centroResultadoParent</code>.
	 * 
	 * @param centroResultadoParent
	 */
	public void setCentroResultadoParent(CentroResultado centroResultadoParent) {

		this.centroResultadoParent = centroResultadoParent;
	}

	/**
	 * Retorna o valor do atributo <code>responsaveis</code>
	 * 
	 * @return <code>Collection<CentroResultadoAlcadaResponsavel></code>
	 */
	public Collection<CentroResultadoResponsavel> getResponsaveis() {

		return responsaveis;
	}

	/**
	 * Define o valor do atributo <code>responsaveis</code>.
	 * 
	 * @param responsaveis
	 */
	public void setResponsaveis(Collection<CentroResultadoResponsavel> responsaveis) {

		this.responsaveis = responsaveis;
	}

	/**
	 * Retorna o valor do atributo <code>codigoParent</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getCodigoParent() {

		return codigoParent;
	}

	/**
	 * Define o valor do atributo <code>codigoParent</code>.
	 * 
	 * @param codigoParent
	 */
	public void setCodigoParent(String codigoParent) {

		this.codigoParent = codigoParent;
	}

	/**
	 * Retorna o valor do atributo <code>codigoSistemaOrigem</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getCodigoSistemaOrigem() {

		return codigoSistemaOrigem;
	}

	/**
	 * Define o valor do atributo <code>codigoSistemaOrigem</code>.
	 * 
	 * @param codigoSistemaOrigem
	 */
	public void setCodigoSistemaOrigem(String codigoSistemaOrigem) {

		this.codigoSistemaOrigem = codigoSistemaOrigem;
	}

	public Boolean getHasParent() {
		return this.centroResultadoParent != null;
	}

	public void setHasParent(Boolean hasParent) {
		this.hasParent = hasParent;
	}

}
