package br.com.centralit.api.model;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/06/2015 - 14:10:38
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Entity
@JsonIgnoreProperties({ "$checked" })
public class CentroResultadoDelegacao extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	@JoinColumn(name="centroresultadorespalcada_id")
	private CentroResultadoResponsavelAlcada centroResultadoResponsavelAlcada;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	private Colaborador delegado;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class })
	private Usuario responsavelRevogacao;

	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	private Calendar dataRevogacao;

	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class })
	private Boolean revogada;

	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	private Calendar dataInicioDelegacao;

	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	private Calendar dataFimDelegacao;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	@JoinColumn(name="tipoabrangenciadelegacao_id")
	private Dominio dominioTipoAbrangenciaDelegacao;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "centroResultadoDelegacao", cascade = CascadeType.ALL)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	private List<CentroResultadoDelegacaoRequisicao> requisicoes;

	/**
	 * Retorna o valor do atributo <code>centroResultadoResponsavelAlcada</code>
	 * 
	 * @return <code>CentroResultadoResponsavelAlcada</code>
	 */
	public CentroResultadoResponsavelAlcada getCentroResultadoResponsavelAlcada() {

		return centroResultadoResponsavelAlcada;
	}

	/**
	 * Define o valor do atributo <code>centroResultadoResponsavelAlcada</code>.
	 * 
	 * @param centroResultadoResponsavelAlcada
	 */
	public void setCentroResultadoResponsavelAlcada(CentroResultadoResponsavelAlcada centroResultadoResponsavelAlcada) {

		this.centroResultadoResponsavelAlcada = centroResultadoResponsavelAlcada;
	}

	/**
	 * Retorna o valor do atributo <code>dataRevogacao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataRevogacao() {

		return dataRevogacao;
	}

	/**
	 * Define o valor do atributo <code>dataRevogacao</code>.
	 * 
	 * @param dataRevogacao
	 */
	public void setDataRevogacao(Calendar dataRevogacao) {

		this.dataRevogacao = dataRevogacao;
	}

	/**
	 * Retorna o valor do atributo <code>revogada</code>
	 * 
	 * @return <code>Boolean</code>
	 */
	public Boolean getRevogada() {

		return revogada;
	}

	/**
	 * Define o valor do atributo <code>revogada</code>.
	 * 
	 * @param revogada
	 */
	public void setRevogada(Boolean revogada) {

		this.revogada = revogada;
	}

	/**
	 * Retorna o valor do atributo <code>dataInicioDelegacao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataInicioDelegacao() {

		return dataInicioDelegacao;
	}

	/**
	 * Define o valor do atributo <code>dataInicioDelegacao</code>.
	 * 
	 * @param dataInicioDelegacao
	 */
	public void setDataInicioDelegacao(Calendar dataInicioDelegacao) {

		this.dataInicioDelegacao = dataInicioDelegacao;
	}

	/**
	 * Retorna o valor do atributo <code>dataFimDelegacao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataFimDelegacao() {

		return dataFimDelegacao;
	}

	/**
	 * Define o valor do atributo <code>dataFimDelegacao</code>.
	 * 
	 * @param dataFimDelegacao
	 */
	public void setDataFimDelegacao(Calendar dataFimDelegacao) {

		this.dataFimDelegacao = dataFimDelegacao;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoAbrangenciaDelegacao</code>
	 * 
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoAbrangenciaDelegacao() {

		return dominioTipoAbrangenciaDelegacao;
	}

	/**
	 * Define o valor do atributo <code>dominioTipoAbrangenciaDelegacao</code>.
	 * 
	 * @param dominioTipoAbrangenciaDelegacao
	 */
	public void setDominioTipoAbrangenciaDelegacao(Dominio dominioTipoAbrangenciaDelegacao) {

		this.dominioTipoAbrangenciaDelegacao = dominioTipoAbrangenciaDelegacao;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>delegado</code>
	 * 
	 * @return <code>Colaborador</code>
	 */
	public Colaborador getDelegado() {

		return delegado;
	}

	/**
	 * Define o valor do atributo <code>delegado</code>.
	 * 
	 * @param delegado
	 */
	public void setDelegado(Colaborador delegado) {

		this.delegado = delegado;
	}

	/**
	 * Retorna o valor do atributo <code>responsavelRevogacao</code>
	 * 
	 * @return <code>Usuario</code>
	 */
	public Usuario getResponsavelRevogacao() {

		return responsavelRevogacao;
	}

	/**
	 * Define o valor do atributo <code>responsavelRevogacao</code>.
	 * 
	 * @param responsavelRevogacao
	 */
	public void setResponsavelRevogacao(Usuario responsavelRevogacao) {

		this.responsavelRevogacao = responsavelRevogacao;
	}

	/**
	 * Retorna o valor do atributo <code>requisicoess</code>
	 * 
	 * @return <code>List<CentroResultadoDelegacaoRequisicao></code>
	 */
	public List<CentroResultadoDelegacaoRequisicao> getRequisicoes() {

		return requisicoes;
	}

	/**
	 * Define o valor do atributo <code>requisicoes</code>.
	 * 
	 * @param requisicoes
	 */
	public void setRequisicoes(List<CentroResultadoDelegacaoRequisicao> requisicoes) {

		this.requisicoes = requisicoes;
	}
	
	@JsonIgnore
	public List<String> getRequisicoesStr() {
		List<String> result = new ArrayList<String>();
		if (this.getRequisicoes() != null) {
			for (CentroResultadoDelegacaoRequisicao centroResultadoDelegacaoRequisicao : this.getRequisicoes()) {
				result.add(centroResultadoDelegacaoRequisicao.getRequisicao());
			}
		}
		return result;
	}

}
