package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 22/08/2015 - 14:10:38
 * 
 * @version 1.0.0
 * 
 * @author renato.jesus - (<a href="mailto:renato.jesus@centralit.com.br">renato.jesus@centralit.com.br</a>)
 * 
 */
@Entity
@Table(name="CentroResultadoDelegRequisicao")
@JsonIgnoreProperties({ "$checked" })
public class CentroResultadoDelegacaoRequisicao extends PersistentObject {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;
	
	/** Atributo requisicao. */
	private String requisicao;
	
	/** Atributo centroResultadoDelegacao. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private CentroResultadoDelegacao centroResultadoDelegacao;
	
	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>requisicao</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getRequisicao() {
		return requisicao;
	}

	/**
	 * Define o valor do atributo <code>requisicao</code>.
	 * 
	 * @param requisicao
	 */
	public void setRequisicao(String requisicao) {
		this.requisicao = requisicao;
	}

	/**
	 * Retorna o valor do atributo <code>centroResultadoDelegacao</code>
	 * 
	 * @return <code>CentroResultadoDelegacao</code>
	 */
	public CentroResultadoDelegacao getCentroResultadoDelegacao() {
		return centroResultadoDelegacao;
	}

	/**
	 * Define o valor do atributo <code>centroResultadoDelegacao</code>.
	 * 
	 * @param centroResultadoDelegacao
	 */
	public void setCentroResultadoDelegacao(CentroResultadoDelegacao centroResultadoDelegacao) {
		this.centroResultadoDelegacao = centroResultadoDelegacao;
	}
}
