package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 30/06/2015 - 14:08:49
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Entity
@JsonIgnoreProperties({ "$selected","$index" })
public class CentroResultadoResponsavel extends PersistentObjectAudit {

    /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo id. */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class,
    			ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class})
    private Long id;
        
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private CentroResultado centroResultado;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class,
    			ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class,
    			ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class,
				ViewsTabelasCorp.CentroResultadoSubstituicao.class})
    private Colaborador responsavel;
         
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "centroResultadoResponsavel", cascade = CascadeType.ALL)
	@JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class,
				ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class,})
	private Collection<CentroResultadoResponsavelAlcada> alcadas;
    
     /**
     * Retorna o valor do atributo <code>centroResultado</code>
     *
     * @return <code>CentroResultado</code>
     */
    public CentroResultado getCentroResultado() {

        return centroResultado;
    }

    /**
     * Define o valor do atributo <code>centroResultado</code>.
     *
     * @param centroResultado
     */
    public void setCentroResultado(CentroResultado centroResultado) {

        this.centroResultado = centroResultado;
    }
     
     /**
     * Retorna o valor do atributo <code>responsavel</code>
     *
     * @return <code>Responsavel</code>
     */
    public Colaborador getResponsavel() {

        return responsavel;
    }

    /**
     * Define o valor do atributo <code>responsavel</code>.
     *
     * @param responsavel
     */
    public void setResponsavel(Colaborador responsavel) {

        this.responsavel = responsavel;
    }
     
     /**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	
	/**
	 * Retorna o valor do atributo <code>alcadas</code>
	 *
	 * @return <code>Collection<CentroResultadoResponsavelAlcada></code>
	 */
	public Collection<CentroResultadoResponsavelAlcada> getAlcadas() {
	
		return alcadas;
	}

	
	/**
	 * Define o valor do atributo <code>alcadas</code>.
	 *
	 * @param alcadas 
	 */
	public void setAlcadas(Collection<CentroResultadoResponsavelAlcada> alcadas) {
	
		this.alcadas = alcadas;
	}
}
