package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 16/07/2015 - 14:08:49
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Entity
@Table(name="CentroResultadoRespAlcada")
@JsonIgnoreProperties({ "$selected" })
public class CentroResultadoResponsavelAlcada extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class, ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	private CentroResultadoResponsavel centroResultadoResponsavel;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class, ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class })
	private Alcada alcada;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "centroResultadoResponsavelAlcada")
	@JsonView({ ViewsTabelasCorp.CentroResultadoEditView.class })
	private Collection<CentroResultadoDelegacao> delegacoes;

	public Long getId() {

		return id;
	}

	public void setId(Long id) {

		this.id = id;
	}

	public CentroResultadoResponsavel getCentroResultadoResponsavel() {

		return centroResultadoResponsavel;
	}

	public void setCentroResultadoResponsavel(CentroResultadoResponsavel centroResultadoResponsavel) {

		this.centroResultadoResponsavel = centroResultadoResponsavel;
	}

	public Alcada getAlcada() {

		return alcada;
	}

	public void setAlcada(Alcada alcada) {

		this.alcada = alcada;
	}

	/**
	 * Retorna o valor do atributo <code>delegacoes</code>
	 * 
	 * @return <code>Collection<CentroResultadoDelegacaoResponsavel></code>
	 */
	public Collection<CentroResultadoDelegacao> getDelegacoes() {

		return delegacoes;
	}

	/**
	 * Define o valor do atributo <code>delegacoes</code>.
	 * 
	 * @param delegacoes
	 */
	public void setDelegacoes(Collection<CentroResultadoDelegacao> delegacoes) {

		this.delegacoes = delegacoes;
	}

}
