package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 16/07/2015 - 14:08:49
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Entity
@JsonIgnoreProperties({ "$selected" })
public class CentroResultadoSubstituicao extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsTabelasCorp.CentroResultadoSubstituicao.class })
	private CentroResultadoResponsavel centroResultadoResponsavel;
	
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsTabelasCorp.CentroResultadoSubstituicao.class})
    private Colaborador substituto;

	@Override
    public Long getId() {
		return id;
	}

	
	/**
	 * Retorna o valor do atributo <code>centroResultadoResponsavel</code>
	 *
	 * @return <code>CentroResultadoResponsavel</code>
	 */
	public CentroResultadoResponsavel getCentroResultadoResponsavel() {
	
		return centroResultadoResponsavel;
	}

	
	/**
	 * Define o valor do atributo <code>centroResultadoResponsavel</code>.
	 *
	 * @param centroResultadoResponsavel 
	 */
	public void setCentroResultadoResponsavel(CentroResultadoResponsavel centroResultadoResponsavel) {
	
		this.centroResultadoResponsavel = centroResultadoResponsavel;
	}

	
	/**
	 * Retorna o valor do atributo <code>substituto</code>
	 *
	 * @return <code>Colaborador</code>
	 */
	public Colaborador getSubstituto() {
	
		return substituto;
	}

	
	/**
	 * Define o valor do atributo <code>substituto</code>.
	 *
	 * @param substituto 
	 */
	public void setSubstituto(Colaborador substituto) {
	
		this.substituto = substituto;
	}

	
	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id 
	 */
	public void setId(Long id) {
	
		this.id = id;
	}

	
}
