package br.com.centralit.api.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;
import org.hibernate.envers.NotAudited;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;
import br.com.centralit.framework.util.UtilObjeto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * @since 05/12/2014 - 11:12:51
 *
 * @version 1.0.0
 *
 * @author ally.barra
 *
 */
@Audited
@AuditTable(value = "ClassificMat_aud")
@Entity
@JsonIgnoreProperties({ "$selected", "mostrarFilhos", "$selected" })
public class ClassificacaoMaterial extends PersistentObjectAuditOrganizacao implements Cloneable {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -6596803383105986337L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo codigo. */
	@Column(length = 30)
	@JsonView({ Views.ClassificacaoMaterialListView.class, Views.ClassificacaoMaterialSearchView.class, Views.MaterialEditView.class, Views.MaterialConsultaInfo.class  })
	private String codigo;

	/** Atributo descricao. */
	@Column(length = 500)
	@JsonView({ Views.ClassificacaoMaterialListView.class, Views.MaterialEditView.class, Views.ClassificacaoMaterialSearchView.class, Views.PessoaEditView.class, Views.MaterialAutoCompleteView.class, Views.MaterialConsultaInfo.class })
	private String descricao;

	/** Atributo dominioTipoClassificacaoMaterial. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.ClassificacaoMaterialListView.class, Views.ClassificacaoMaterialSearchView.class, Views.MaterialConsultaInfo.class })
	@JoinColumn(name="tipoclassificacaomaterial_id")
	private Dominio dominioTipoClassificacaoMaterial;

	/** Atributo dominioTipoMaterial. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.ClassificacaoMaterialListView.class, Views.ClassificacaoMaterialSearchView.class, Views.MaterialConsultaInfo.class })
	private Dominio dominioTipoMaterial;

	/** Atributo classificacaoMaterialParent. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ Views.MaterialEditView.class, Views.ClassificacaoMaterialListView.class, Views.ClassificacaoMaterialSearchView.class , Views.MaterialAutoCompleteView.class, Views.MaterialConsultaInfo.class})
	private ClassificacaoMaterial classificacaoMaterialParent;

	@Transient
	@JsonView({ Views.ClassificacaoMaterialSearchView.class, Views.MaterialConsultaInfo.class })
	private List<ClassificacaoMaterial> classificacaoMaterialFilhos;

	@Transient
	@JsonView({ Views.GenericView.class, Views.MaterialEditView.class, Views.MaterialAutoCompleteView.class, Views.ClassificacaoMaterialEditView.class, Views.MaterialConsultaInfo.class })
	private String codigoEDescricao;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 *
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}

	/**
	 * Define o valor do atributo <code>codigo</code>.
	 *
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 *
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoClassificacaoMaterial</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoClassificacaoMaterial() {

		return dominioTipoClassificacaoMaterial;
	}

	/**
	 * Define o valor do atributo <code>dominioTipoClassificacaoMaterial</code>.
	 *
	 * @param dominioTipoClassificacaoMaterial
	 */
	public void setDominioTipoClassificacaoMaterial(Dominio dominioTipoClassificacaoMaterial) {

		this.dominioTipoClassificacaoMaterial = dominioTipoClassificacaoMaterial;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoMaterial</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoMaterial() {

		return dominioTipoMaterial;
	}

	/**
	 * Define o valor do atributo <code>dominioTipoMaterial</code>.
	 *
	 * @param dominioTipoMaterial
	 */
	public void setDominioTipoMaterial(Dominio dominioTipoMaterial) {

		this.dominioTipoMaterial = dominioTipoMaterial;
	}

	/**
	 * Retorna o valor do atributo <code>classificacaoMaterialParent</code>
	 *
	 * @return <code>ClassificacaoMaterial</code>
	 */
	public ClassificacaoMaterial getClassificacaoMaterialParent() {

		return classificacaoMaterialParent;
	}

	/**
	 * Define o valor do atributo <code>classificacaoMaterialParent</code>.
	 *
	 * @param classificacaoMaterialParent
	 */
	public void setClassificacaoMaterialParent(ClassificacaoMaterial classificacaoMaterialParent) {

		this.classificacaoMaterialParent = classificacaoMaterialParent;
	}

	/**
	 * Retorna o valor do atributo <code>classificacaoMaterialFilhos</code>
	 *
	 * @return <code>List<ClassificacaoMaterial></code>
	 */
	@JsonView({ Views.ClassificacaoMaterialSearchView.class })
	public List<ClassificacaoMaterial> getClassificacaoMaterialFilhos() {

		if (!UtilObjeto.isReferencia(this.classificacaoMaterialFilhos)) {

			this.classificacaoMaterialFilhos = new ArrayList<ClassificacaoMaterial>();
		}

		return classificacaoMaterialFilhos;
	}

	/**
	 * Define o valor do atributo <code>classificacaoMaterialFilhos</code>.
	 *
	 * @param classificacaoMaterialFilhos
	 */
	public void setClassificacaoMaterialFilhos(List<ClassificacaoMaterial> classificacaoMaterialFilhos) {

		this.classificacaoMaterialFilhos = classificacaoMaterialFilhos;
	}

	/**
	 * {@inheritDoc}
	 */
	public ClassificacaoMaterial clone() {

		try {

			return (ClassificacaoMaterial) super.clone();

		} catch (CloneNotSupportedException ex) {

			return null;
		}
	}

	public String getCodigoEDescricao() {
		return codigo + " - " + descricao;
	}

	public void setCodigoEDescricao(String codigoEDescricao) {
		this.codigoEDescricao = codigoEDescricao;
	}

}
