package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 26/11/2014 - 09:51:15
 * 
 * @version 1.0.0
 * 
 * @author david.silva
 * 
 */
@Entity
public class Pais extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -8798203126933021163L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	protected Long id;

	/** Atributo codigo. */
	@Column(length = 30)
	@JsonView({ Views.PaisListView.class, Views.LocalizacaoListView.class, Views.OrganizacaoListView.class })
	private String codigo;

	/** Atributo nome. */
	@Column(length = 250)
	@JsonView({ Views.EnderecoListView.class, Views.PaisListView.class, Views.BairroListView.class, Views.CidadeListView.class, Views.EstadoListView.class, Views.RegiaoListView.class, Views.LocalizacaoListView.class, Views.OrganizacaoListView.class, Views.PessoaEditView.class })
	private String nome;

	/** Atributo sigla. */
	@Column(length = 5)
	@JsonView({ Views.EstadoListView.class, Views.CidadeListView.class, Views.RegiaoListView.class, Views.PaisListView.class, Views.BairroListView.class, Views.LocalizacaoListView.class, Views.OrganizacaoListView.class })
	private String sigla;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public Pais() {

		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param codigo
	 * @param nome
	 * @param sigla
	 */
	public Pais( String codigo, String nome, String sigla ) {

		this();

		this.codigo = codigo;
		this.nome = nome;
		this.sigla = sigla;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param nome
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}

	/**
	 * Define o valor do atributo <code>codigo</code>.
	 * 
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}

	/**
	 * Retorna o valor do atributo <code>sigla</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getSigla() {

		return sigla;
	}

	/**
	 * Define o valor do atributo <code>sigla</code>.
	 * 
	 * @param sigla
	 */
	public void setSigla(String sigla) {

		this.sigla = sigla;
	}

}
