package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.AlcadaNivelAutoridadeDao;
import br.com.centralit.api.model.Alcada;
import br.com.centralit.api.model.AlcadaNivelAutoridade;
import br.com.centralit.api.service.AlcadaNivelAutoridadeService;
import br.com.centralit.api.service.NivelAutoridadeService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 23/06/2015 - 11:21:16
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Service("alcadaNivelAutoridadeService")
public class AlcadaNivelAutoridadeServiceImpl extends GenericServiceImpl<AlcadaNivelAutoridade, Long> implements AlcadaNivelAutoridadeService {

	/** Atributo bemPatrimonialService. */
	@Autowired
	private NivelAutoridadeService nivelAutoridadeService;
	
    private AlcadaNivelAutoridadeDao alcadaNivelAutoridadeDao;

    /**
     * Responsável pela criação de novas instâncias desta classe.
     * @param alcadaNivelAutoridadeDao
     * @param validator
     */
    @Autowired
	public AlcadaNivelAutoridadeServiceImpl(AlcadaNivelAutoridadeDao alcadaNivelAutoridadeDao,  @Qualifier("alcadaNivelAutoridadeValidator") Validator validator) {
    	this.dao = alcadaNivelAutoridadeDao;
        this.alcadaNivelAutoridadeDao = alcadaNivelAutoridadeDao;
    	this.validator = validator;
	}

	/**
	 *
	 */
	@Override
	public void montarAlcadaNivelAutoridade(Alcada alcada) {

		// PERCORRE A LISTA DE ALCADANIVELAUTORIDADE
		if(alcada.getNiveisAutoridades() != null){
			for(AlcadaNivelAutoridade alcadaNivelAutoridade : alcada.getNiveisAutoridades()) {			
				// CARREGA O OBJETO ALCADANIVELAUTORIDADE
				alcadaNivelAutoridade.setNivelAutoridade(this.nivelAutoridadeService.getReference(alcadaNivelAutoridade.getNivelAutoridade().getId()));	
				alcadaNivelAutoridade.setAlcada(alcada);
			}
		}
	}
    
}
