package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.CentroResultadoResponsavelAlcadaDao;
import br.com.centralit.api.model.CentroResultadoResponsavel;
import br.com.centralit.api.model.CentroResultadoResponsavelAlcada;
import br.com.centralit.api.service.AlcadaService;
import br.com.centralit.api.service.CentroResultadoResponsavelAlcadaService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilObjeto;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 30/06/2015 - 14:07:09
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Service("centroResultadoResponsavelAlcadaService")
public class CentroResultadoResponsavelAlcadaServiceImpl extends GenericServiceImpl<CentroResultadoResponsavelAlcada, Long> implements CentroResultadoResponsavelAlcadaService {

	@Autowired
	private AlcadaService alcadaService;
	
	@Autowired
	public CentroResultadoResponsavelAlcadaServiceImpl(CentroResultadoResponsavelAlcadaDao centroResultadoResponsavelAlcadaDao,  
			@Qualifier("centroResultadoResponsavelAlcadaValidator") Validator validator) {
    	this.dao = centroResultadoResponsavelAlcadaDao;
    	this.validator = validator;
	}

	@Override
	public void montarCentroResultadoResponsavelAlcada(CentroResultadoResponsavel centroResultadoResponsavel) {
		
		// PERCORRE A LISTA DE centroResultadoResponsavelAlcada
		for(CentroResultadoResponsavelAlcada centroResultadoResponsavelAlcada : centroResultadoResponsavel.getAlcadas()) {
			this.resolveTransientAlcada(centroResultadoResponsavelAlcada);
			
			centroResultadoResponsavelAlcada.setCentroResultadoResponsavel(centroResultadoResponsavel);
			
			
		}
		
	}

	private void resolveTransientAlcada(CentroResultadoResponsavelAlcada centroResultadoResponsavelAlcada) {
		if(UtilObjeto.isReferencia(centroResultadoResponsavelAlcada.getAlcada()) && UtilObjeto.isReferencia(centroResultadoResponsavelAlcada.getAlcada().getId())) {
			centroResultadoResponsavelAlcada.setAlcada(this.alcadaService.find(centroResultadoResponsavelAlcada.getAlcada().getId()));
		}
	}

}
