package br.com.centralit.api.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.service.DominioService;
import br.com.centralit.api.service.MenuService;
import br.com.centralit.api.service.ModuloService;
import br.com.centralit.api.service.PaginaService;
import br.com.centralit.framework.model.Menu;
import br.com.centralit.framework.model.MenuFile;
import br.com.centralit.framework.model.Pagina;
import br.com.centralit.framework.model.UtilStartup;

@Service("inicializarTabelasCorpService")
public class InicializarTabelasCorpServiceImpl extends UtilStartup {

	@Autowired
	private PaginaService paginaService;

	@Autowired
	private MenuService menuService;

	@Autowired
	private DominioService dominioService;

	@Autowired
	private ModuloService moduloService;
	
	private Menu menuTabelasCorp;

	public void gerarCarga() {
		criarPaginasMenus();
		this.menuService.adicionarGrupoMasterMenu(menuTabelasCorp);
	}
	
	/**
	 * 
	 * Método responsável por criar paginas e menus do modulo
	 * 
	 * @author wilker.machado
	 * 
	 */
	private void criarPaginasMenus() {

		moduloSelecionado = this.moduloService.getModuloPorBaseUrl(BASE_URL_TABELAS_CORP, null);

		dominioJS = this.dominioService.findByChaveAndNome(TIPO_FILE, TIPO_FILE_JS);

		// Menu pai Corporativo
		menuTabelasCorp = new Menu("Corporativo", null, null, null, 3, COR_TABELASCORP, CSS_MENU_TABELASCORP, OPACIDADE_MENU_TABELASCORP, CLASSE_TABELASCORP, ICONE_MENU_CORPORATIVO, moduloSelecionado);
		List<MenuFile> includesTabelasCorp = new ArrayList<MenuFile>();
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/TelefoneRepository.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/TelefoneRepository.min.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/SeguradoraRepository.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/SeguradoraRepository.min.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/FornecedorRepository.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/FornecedorRepository.min.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ColaboradorRepository.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ColaboradorRepository.min.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ObservacaoRepository.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ObservacaoRepository.min.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/FuncaoRepository.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/FuncaoRepository.min.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/EnderecoRepository.js", dominioJS, menuTabelasCorp));
		includesTabelasCorp.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/EnderecoRepository.min.js", dominioJS, menuTabelasCorp));
		menuTabelasCorp.setIncludes(includesTabelasCorp);
		menuTabelasCorp = this.menuService.mergeIfNotExist(menuTabelasCorp);

		// Submenu Localidades
		Menu menuLocalidades = new Menu("Localidades", null, menuTabelasCorp, 0, 1, null, null, null, null, moduloSelecionado);
		menuLocalidades.setParent(menuTabelasCorp);
		menuLocalidades = this.menuService.mergeIfNotExist(menuLocalidades);
		// Menu País
		Pagina pgPais = new Pagina("País", "/cit-tabelas-corp-web/html/pais/pais.html");
		pgPais = this.paginaService.saveIfNotExist(pgPais);
		Menu menuPais = new Menu("País", pgPais, menuLocalidades, null, 1, null, null, null, null, moduloSelecionado);
		menuPais.setIncludes(this.gerarArquivosMenu(menuPais, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Pais", true, true, true));
		this.menuService.mergeIfNotExist(menuPais);
		// Menu Região
		Pagina pgRegiao = new Pagina("Região", "/cit-tabelas-corp-web/html/regiao/regiao.html");
		pgRegiao = this.paginaService.saveIfNotExist(pgRegiao);
		Menu menuRegiao = new Menu("Região", pgRegiao, menuLocalidades, null, 2, null, null, null, null, moduloSelecionado);
		menuRegiao.setIncludes(this.gerarArquivosMenu(menuRegiao, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Regiao", true, true, true));
		this.menuService.mergeIfNotExist(menuRegiao);
		// Menu Estado
		Pagina pgEstado = new Pagina("Estado", "/cit-tabelas-corp-web/html/estado/estado.html");
		pgEstado = this.paginaService.saveIfNotExist(pgEstado);
		Menu menuEstado = new Menu("Estado", pgEstado, menuLocalidades, null, 3, null, null, null, null, moduloSelecionado);
		menuEstado.setIncludes(this.gerarArquivosMenu(menuEstado, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Estado", true, true, true));
		this.menuService.mergeIfNotExist(menuEstado);
		// Menu Cidade
		Pagina pgCidade = new Pagina("Cidade", "/cit-tabelas-corp-web/html/cidade/cidade.html");
		pgCidade = this.paginaService.saveIfNotExist(pgCidade);
		Menu menuCidade = new Menu("Cidade", pgCidade, menuLocalidades, null, 4, null, null, null, null, moduloSelecionado);
		menuCidade.setIncludes(this.gerarArquivosMenu(menuCidade, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Cidade", true, true, true));
		this.menuService.mergeIfNotExist(menuCidade);
		// Menu Bairro
		Pagina pgBairro = new Pagina("Bairro", "/cit-tabelas-corp-web/html/bairro/bairro.html");
		pgBairro = this.paginaService.saveIfNotExist(pgBairro);
		Menu menuBairro = new Menu("Bairro", pgBairro, menuLocalidades, null, 5, null, null, null, null, moduloSelecionado);
		menuBairro.setIncludes(this.gerarArquivosMenu(menuBairro, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Bairro", true, true, true));
		this.menuService.mergeIfNotExist(menuBairro);
		// Menu Endereço
		Pagina pgEndereco = new Pagina("Endereço", "/cit-tabelas-corp-web/html/endereco/endereco.html");
		pgEndereco = this.paginaService.saveIfNotExist(pgEndereco);
		Menu menuEndereco = new Menu("Endereço", pgEndereco, menuLocalidades, null, 6, null, null, null, null, moduloSelecionado);
		menuEndereco.setIncludes(this.gerarArquivosMenu(menuEndereco, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Endereco", true, true, true));
		this.menuService.mergeIfNotExist(menuEndereco);
		// Menu Localização
		Pagina pgLocalizacao = new Pagina("Localização", "/cit-tabelas-corp-web/html/localizacao/localizacao.html");
		pgLocalizacao = this.paginaService.saveIfNotExist(pgLocalizacao);
		Menu menuLocalizacao = new Menu("Localização", pgLocalizacao, menuLocalidades, null, 7, null, null, null, null, moduloSelecionado);
		menuLocalizacao.setIncludes(this.gerarArquivosMenu(menuLocalizacao, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Localizacao", true, true, true));
		this.menuService.mergeIfNotExist(menuLocalizacao);

		// Submenu Pessoas (Agentes)
		Menu menuPessoas = new Menu("Pessoas (Agentes)", null, menuTabelasCorp, 1, 3, null, null, null, null, moduloSelecionado);
		menuPessoas.setParent(menuTabelasCorp);
		menuPessoas = this.menuService.mergeIfNotExist(menuPessoas);
		// Menu Cadastro de pessoas
		Pagina pgPessoa = new Pagina("Cadastro de pessoas", "/cit-tabelas-corp-web/html/pessoa/pessoa.html");
		pgPessoa = this.paginaService.saveIfNotExist(pgPessoa);
		Menu menuPessoa = new Menu("Cadastro de pessoas", pgPessoa, menuPessoas, null, 1, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFilePessoa = new ArrayList<MenuFile>();
		filesMenuFilePessoa.addAll(this.gerarArquivosMenu(menuPessoa, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Pessoa", true, true, true));
		filesMenuFilePessoa.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ParceiroRepository.js", dominioJS, menuPessoa));
		filesMenuFilePessoa.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ParceiroRepository.min.js", dominioJS, menuPessoa));
		menuPessoa.setIncludes(filesMenuFilePessoa);
		this.menuService.mergeIfNotExist(menuPessoa);

		// Menu Cadastro de Funcao
		Pagina pgFuncao = new Pagina("Função", "/cit-tabelas-corp-web/html/funcao/funcao.html");
		pgFuncao = this.paginaService.saveIfNotExist(pgFuncao);
		Menu menuFuncao = new Menu("Função", pgFuncao, menuPessoas, null, 2, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileFuncao = new ArrayList<MenuFile>();
		filesMenuFileFuncao.addAll(this.gerarArquivosMenu(menuFuncao, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Funcao", true, true, true));
		menuFuncao.setIncludes(filesMenuFileFuncao);
		this.menuService.mergeIfNotExist(menuFuncao);

		// Submenu Atributos personalizados
		Menu menuAtributos = new Menu("Atributos personalizados", null, menuTabelasCorp, 1, 4, null, null, null, null, moduloSelecionado);
		menuAtributos.setParent(menuTabelasCorp);
		menuAtributos = this.menuService.mergeIfNotExist(menuAtributos);
		// Menu Definir características
		Pagina pgCaracteristica = new Pagina("Definir características", "/cit-tabelas-corp-web/html/caracteristica/caracteristica.html");
		pgCaracteristica = this.paginaService.saveIfNotExist(pgCaracteristica);
		Menu menuCaracteristica = new Menu("Definir características", pgCaracteristica, menuAtributos, null, 1, null, null, null, null, moduloSelecionado);
		menuCaracteristica.setIncludes(this.gerarArquivosMenu(menuCaracteristica, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Caracteristica", true, true, true));
		this.menuService.mergeIfNotExist(menuCaracteristica);
		//Menu Unidade Medida
		Pagina pgUnidadeMedida = new Pagina("Unidade Medida", "/cit-tabelas-corp-web/html/unidadeMedida/unidadeMedida.html");
		pgUnidadeMedida = this.paginaService.saveIfNotExist(pgUnidadeMedida);
		Menu menuUnidadeMedida = new Menu("Unidade Medida", pgUnidadeMedida, menuAtributos, null, 2, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuUnidadeMedida = new ArrayList<MenuFile>();
		filesMenuUnidadeMedida.addAll(this.gerarArquivosMenu(menuUnidadeMedida, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "UnidadeMedida", true, true, true));
		filesMenuUnidadeMedida.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/UnidadeMedidaRepository.js", dominioJS, menuUnidadeMedida));
		filesMenuUnidadeMedida.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/UnidadeMedidaRepository.min.js", dominioJS, menuUnidadeMedida));
		menuUnidadeMedida.setIncludes(filesMenuUnidadeMedida);
		this.menuService.mergeIfNotExist(menuUnidadeMedida);
		
		// Submenu Estrutura organizacional
		Menu menuEstrutura = new Menu("Estrutura organizacional", null, menuTabelasCorp, 0, 2, null, null, null, null, moduloSelecionado);
		menuEstrutura.setParent(menuTabelasCorp);
		menuEstrutura = this.menuService.mergeIfNotExist(menuEstrutura);

		// Menu Organizacao - gerei no portal por causa do login, mas vai ficar no menu do tabelas corp
		Pagina pgOrganizacao = new Pagina("Órgão", "/cit-portal-web/html/organizacao/organizacao.html");
		pgOrganizacao = this.paginaService.saveIfNotExist(pgOrganizacao);
		Menu menuOrganizacao = new Menu("Órgão", pgOrganizacao, menuEstrutura, null, 1, null, null, null, null, moduloSelecionado);
		menuOrganizacao.setIncludes(this.gerarArquivosMenu(menuOrganizacao, CIT_PORTAL_WEB_ANGULAR_CUSTOM, "Organizacao", true, true, true));
		this.menuService.mergeIfNotExist(menuOrganizacao);

		// Menu Nivel de autoridade
		Pagina pgNivelAutoridade = new Pagina("Nivel de autoridade", "/cit-tabelas-corp-web/html/nivelAutoridade/nivelAutoridade.html");
		pgNivelAutoridade = this.paginaService.saveIfNotExist(pgNivelAutoridade);
		Menu menuNivelAutoridade = new Menu("Nível de autoridade", pgNivelAutoridade, menuEstrutura, null, 2, null, null, null, null, moduloSelecionado);
		menuNivelAutoridade.setIncludes(this.gerarArquivosMenu(menuNivelAutoridade, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "NivelAutoridade", true, true, true));
		this.menuService.mergeIfNotExist(menuNivelAutoridade);

		// Submenu Comissao
		Menu menuComissao = new Menu("Comissão", null, menuTabelasCorp, 1, 5, null, null, null, null, moduloSelecionado);
		menuComissao.setParent(menuTabelasCorp);
		menuComissao = this.menuService.mergeIfNotExist(menuComissao);

		// Menu Cadastro das unidades
		Pagina pgEstrutura = new Pagina("Cadastro das unidades", "/cit-tabelas-corp-web/html/estruturaOrganizacional/estruturaOrganizacional.html");
		pgEstrutura = this.paginaService.saveIfNotExist(pgEstrutura);
		Menu menuEstruturaOrganizacional = new Menu("Cadastro das unidades", pgEstrutura, menuEstrutura, null, 3, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileEstruturaOrganizacional = this.gerarArquivosMenu(menuEstruturaOrganizacional, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "EstruturaOrganizacional", true, true, true);
		filesMenuFileEstruturaOrganizacional.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/EstruturaOrganizacionalResponsavelRepository.js", dominioJS, menuEstruturaOrganizacional));
		filesMenuFileEstruturaOrganizacional.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/EstruturaOrganizacionalResponsavelRepository.min.js", dominioJS, menuEstruturaOrganizacional));
		menuEstruturaOrganizacional.setIncludes(filesMenuFileEstruturaOrganizacional);
		this.menuService.mergeIfNotExist(menuEstruturaOrganizacional);
		// Menu Mapa organizacional
		Pagina pgMapa = new Pagina("Mapa organizacional", "/cit-tabelas-corp-web/html/mapaOrganizacional/mapaOrganizacional.html");
		pgMapa = this.paginaService.saveIfNotExist(pgMapa);
		Menu menuMapa = new Menu("Mapa Organizacional", pgMapa, menuEstrutura, null, 4, null, null, null, null, moduloSelecionado);
		menuMapa.setIncludes(this.gerarArquivosMenu(menuMapa, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "MapaOrganizacional", true, true, true));
		this.menuService.mergeIfNotExist(menuMapa);

		// Menu Comissão
		Pagina pgComissao = new Pagina("Comissão", "/cit-tabelas-corp-web/html/comissao/comissao.html");
		pgComissao = this.paginaService.saveIfNotExist(pgComissao);
		Menu menuComissaoItem = new Menu("Cadastro de comissões", pgComissao, menuComissao, null, 5, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileComissaoIntegrante = this.gerarArquivosMenu(menuComissaoItem, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "Comissao", true, true, true);
		filesMenuFileComissaoIntegrante.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ComissaoIntegranteRepository.js", dominioJS, menuComissaoItem));
		filesMenuFileComissaoIntegrante.add(new MenuFile(CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM + "repository/ComissaoIntegranteRepository.min.js", dominioJS, menuComissaoItem));
		menuComissaoItem.setIncludes(filesMenuFileComissaoIntegrante);
		this.menuService.mergeIfNotExist(menuComissaoItem);

		// Submenu Centro Custo
		Menu menuCentroCusto = new Menu("Centro de custo", null, menuTabelasCorp, null, 6, null, null, null, null, moduloSelecionado);
		menuCentroCusto.setParent(menuTabelasCorp);
		menuCentroCusto = this.menuService.mergeIfNotExist(menuCentroCusto);

		Pagina pgCentroCusto = new Pagina("Centro de custo", "/cit-tabelas-corp-web/html/centroCusto/centroCusto.html");
		pgCentroCusto = this.paginaService.saveIfNotExist(pgCentroCusto);

		Menu menuCentroDeCusto = new Menu("Cadastro de centro de custo", pgCentroCusto, menuCentroCusto, null, 7, null, null, null, null, moduloSelecionado);
		List<MenuFile> menuFileCentroCusto = new ArrayList<MenuFile>();
		menuFileCentroCusto.addAll(this.gerarArquivosMenu(menuCentroDeCusto, CIT_TABELAS_CORP_WEB_ANGULAR_CUSTOM, "CentroCusto", true, true, true));
		menuCentroDeCusto.setIncludes(menuFileCentroCusto);
		this.menuService.mergeIfNotExist(menuCentroDeCusto);
		Logger.getLogger(InicializarTabelasCorpServiceImpl.class).info("Menu executado - InicializarTabelasCorp!");
	}

}
