package br.com.centralit.api.service.validation;

import br.com.centralit.api.model.CentroCusto;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.framework.exception.CodigoErro;

@Component("centroCustoValidator")
public class CentroCustoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return CentroCusto.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

        ValidationUtils.rejectIfEmpty(errors, "descricao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DESCRICAO");

	}
}

