package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.Alcada;
import br.com.centralit.api.service.AlcadaService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.json.Views.GenericView;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 23/06/2015 - 11:21:53
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Controller
@RequestMapping("/rest/alcada")
public class AlcadaController extends GenericController<Alcada>{

	/** Atributo regraEventoService. */
	private AlcadaService alcadaService;
	
	@Autowired
	public AlcadaController(AlcadaService alcadaService) {
		super(alcadaService);
		
		this.alcadaService = alcadaService;
	}
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">415</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author juliana.barbosa
	 *
	 * @param nome
	 * @return
	 */
	@RequestMapping(value = "/listarAlcadas", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper listarAlcadas(@RequestParam(value = "nome") String nome) {

		final Collection<Alcada> listaAlcadas = this.alcadaService.listarAlcadas(nome);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(listaAlcadas, Views.GenericView.class);

		return responseBody;
	}
	
	@Override
	public Class<? extends GenericView> getEditView() {
	
		// TODO Auto-generated method stub
		return Views.AlcadaEditView.class;
	}
	
	@Override
	public Class<? extends GenericView> getListView() {
	
		// TODO Auto-generated method stub
		return Views.GenericView.class;
	}
}
