package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.service.impl.InicializarTabelasCorpServiceImpl;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views.GenericView;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p> Classe genérica por módulo para validações via rest
 *
 * <p><b>Description: </b></p>
 * 
 * @since 18/02/2016 - 10:56:06
 *
 * @version 1.0.0
 *
 * @author rogerio.cassimiro
 *	
 */
@Controller
@RequestMapping("/rest/inicializarCarga")
public class InicializarTabelasCorpController extends GenericController<PersistentObject>{

	@Autowired
	private InicializarTabelasCorpServiceImpl inicializarTabelasCorpService;
	
	/**
	 * Método responsável por inicializar carga do módulo
	 *
	 * @author rogerio.cassimiro
	 *
	 * @return {@link ResponseBodyWrapper}
	 */
	@RequestMapping(value = "/gerarCarga", method = RequestMethod.GET)
	@ResponseBody
    public ResponseBodyWrapper gerarCarga() {
		inicializarTabelasCorpService.gerarCarga();
		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(Boolean.TRUE, GenericView.class);
		return responseBody;
    }
	
}
