package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.api.model.UnidadeMedida;
import br.com.centralit.api.service.UnidadeMedidaService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;

@Controller
@RequestMapping("/rest/unidadeMedida")
public class UnidadeMedidaController extends GenericController<UnidadeMedida>{

	@Autowired
	public UnidadeMedidaController(UnidadeMedidaService unidadeMedidaService) {
		super(unidadeMedidaService);
	}
	
	@RequestMapping(method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper getList() {

		Collection<UnidadeMedida> listaUnidadeMedidas = this.genericService.findAll();

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(listaUnidadeMedidas, ViewsTabelasCorp.UnidadeMedidaListView.class);

		return responseBody;
	}
	
	@Override
	public Class<ViewsTabelasCorp.UnidadeMedidaEditView> getEditView() {
	
		return ViewsTabelasCorp.UnidadeMedidaEditView.class;
	}
	
	@Override
	public Class<ViewsTabelasCorp.UnidadeMedidaListView> getListView() {
	
		return ViewsTabelasCorp.UnidadeMedidaListView.class;
	}
}
