'use strict';

citApp.controller('CentroCustoController', ['$scope', '$translate', '$timeout', 'CentroCustoRepository', function CentroCustoController($scope, $translate, $timeout, CentroCustoRepository ) {

    $scope.centroCusto = {};

    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.limparCentroCusto();
        $scope.edit = true;
        $timeout(function(){
            $scope.centroCustoForm.$submitted = false;
            $scope.centroCustoForm.$setPristine();
        });
    };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchCentroCusto').scope().fetchResult();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(centroCusto){
        $scope.centroCusto = centroCusto;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                CentroCustoRepository.remove($scope.centroCusto).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchCentroCusto').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O CentroCusto
    $scope.saveOrUpdate = function(){
        $scope.centroCustoForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.centroCustoForm.$valid){

            $scope.setLoadingSalva(true);

            CentroCustoRepository.save($scope.centroCusto).then(function(result) {
            	$scope.resetForm();
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
            $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
        }
    };

    // Limpa o formulario preenchido
    $scope.limparCentroCusto = function(){
    	$scope.centroCusto = {};
    };
    
    $scope.limpar = function() {
    	if($scope.centroCusto.id){
    		$scope.centroCusto.descricao = null;
    		$scope.centroCusto.centroCustoParent = null;
    	} else {
    		$scope.centroCusto = {};
    	}
    };

    // Consulta entidade e mostra no formulario
    $scope.getCentroCusto = function(centroCusto, edit){
        $scope.setLoadingGet(true);

        CentroCustoRepository.get(centroCusto.id).then(function(result) {
            $scope.centroCusto = result.originalElement;
            $scope.edit = edit;
            $scope.setLoading(false);
        });
    };

    $scope.findAutoCompleteCentroCustoPai = function(value){
        return CentroCustoRepository.findAutoCompleteCentroCustoByOrganizacao(value, $scope.usuarioLogado.organizacao.id, $scope.centroCusto.id).then(function(result) {
            return result;
        });
    };

}]);
