'use strict';

citApp.controller('CentroCustoListController', ['$scope', 'CentroCustoRepository', '$translate', '$timeout', 'DominioRepository',function CentroCustoListController($scope, CentroCustoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editCentroCusto").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.CODIGO'), value : 'codigo' } , {title : $translate.instant('LABEL.DESCRICAO'), value : 'descricao' } , {title : $translate.instant('CORPORATIVO.LABEL.CENTRO_CUSTO_PAI'), value : 'centroCustoParent.descricao' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'codigo', 'descricao', 'centroCustoParent.descricao'],
        filters : [ {type : 'string', field : 'codigo' } , {type : 'string', field : 'descricao' } , {type : 'string', field : 'centroCustoParent.descricao' }]
    };
    
    $scope.abrirVisualizar = function(edit){
        var centroCusto = $scope.centroCustoChecked;

        if(!centroCusto) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editCentroCusto').scope().getCentroCusto(centroCusto, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);