'use strict';

citApp.controller('PessoaController', ['$scope', 'PessoaRepository', 'DominioRepository', '$filter', 'FuncaoRepository', 'UsuarioRepository', '$translate', '$timeout',
                                       '$injector', 'EstruturaOrganizacionalRepository', 'FornecedorRepository', function PessoaController($scope, PessoaRepository, DominioRepository, $filter,
                                    		   FuncaoRepository, UsuarioRepository, $translate, $timeout, $injector, EstruturaOrganizacionalRepository, FornecedorRepository) {

	$scope.isVisualizar = false;

	$scope.edit = false;

	$scope.tiposPessoa = {};

	$scope.tiposPorte = {};

	$scope.tiposAbrangencia = {};

	$scope.dominiosSexo = {};

	$scope.dominiosEstadoCivil = {};

	$scope.pessoaVH = {};

	$scope.contato =  {};

	$scope.MASK_CNPJ = "99.999.999/9999-99";

	$scope.MASK_CPF = "999.999.999-99";

	$scope.MASK_TELEFONE = "(99) 9999?9-9999";

	// Propriedades Tab Parceiro

	$scope.dominiosTipoParceiroSelecionados = [];

	$scope.dominioTipoParceiro = {};

	$scope.colaborador = {};

	$scope.orgaoExterno = {};

	$scope.portador = {};

	$scope.fornecedor = {};

	$scope.seguradora = {};

	$scope.fornecedorObservacao = {};

	$scope.fornecedorRamoAtividade = {};

	$scope.contatoInvalid = false;

	$scope.apresentarBotaoBloquear = false;

	$scope.moduloAdmMateriaisAtivo = false;

	$scope.pessoa  = {

			telefones : [],

			enderecos : [],
			contatos : []
	};

	$scope.admMateriaisAtivo = $scope.isModuloAtivo("/cit-adm-materiais-web");

	function apresentarTabFalse() {
		$scope.apresentarColaborador = false;
		$scope.apresentarOrgaoExterno = false;
		$scope.apresentarPortador = false;
		$scope.apresentarFornecedor = false;
		$scope.apresentarSeguradora = false;
		$scope.apresentarTerceirizado = false;
	}
	
	apresentarTabFalse();
	
	// listar estruturas
   $scope.findEstrutura = function(value){
	   return EstruturaOrganizacionalRepository.listarEstruturasOrganizacionaisPorOrganizacao(value, $scope.usuarioLogado.organizacao.id).then(function(result){
		   return result;
	   });
   };

	//Obter os dominioPessoa
	DominioRepository.findAllDominio('tipoPessoa').then(function(result) {
		$scope.tiposPessoa = result;
	});

	//Obter os dominioPorte
	DominioRepository.findAllDominio('tipoPorte').then(function(result) {
		$scope.tiposPorte = result;
	});

	//Obter os dominioAbrangencia
	DominioRepository.findAllDominio('tipoAbrangencia').then(function(result) {
		$scope.tiposAbrangencia = result;
	});

	//Obter os dominioSexo
	DominioRepository.findAllDominio('tipoSexo').then(function(result) {
		$scope.dominiosSexo = result;
	});

	//Obter os dominioEstadoCivil
	DominioRepository.findAllDominio('tipoEstadoCivil').then(function(result) {
		$scope.dominiosEstadoCivil = result;
	});

	//Obter os dominioTipoParceiro

	$scope.findAllDominioTipoParceiro = function(){

		DominioRepository.findAllDominio('tipoParceiro').then(function(result) {

			$scope.tiposParceiro = $filter('orderBy')(result, 'originalElement.descricao');

		});

	};
	
	//Método responsável por remover a pessoa
	$scope.removerPessoa = function(){

		$scope.setLoadingRemove(true);

		 PessoaRepository.remove($scope.pessoa).then(function(result) {

			 $scope.setLoadingRemove(false);
			 $scope.resetForm();
			 $scope.showAlert("success",  $translate.instant('MSG.MG001'));

		 });

		 $scope.$modalConfirmInstance.dismiss('cancel');
	};

	//Método responsável por bloquear a pessoa
	$scope.bloquearPessoa = function(){

		// Verificar se o usuario informou a data bloqueio
		if(!$scope.pessoa.dataBloqueio){

			$scope.showAlert('error', $translate.instant('MSG.MG011'));
		}else{

			$scope.saveOrUpdate();
		}
	};
	
	function validarErroFomContato() {
		var retorno = false;
		if($scope.formPessoa.$error && $scope.formPessoa.$error.required && $scope.formPessoa.$error.required.length == 1){
			$scope.formPessoa.$error.required.forEach(function(item){
				if(item.$name === 'cpfContato'){
				   retorno = true;	
				}
			});
			
			if(retorno){
				delete $scope.formPessoa.$error;
				$scope.formPessoa.$invalid = false;
			}
		}
		
	}

	// Salvar Pessoa
	$scope.saveOrUpdate = function() {

		if($scope.pessoa.dataBloqueio){
			$scope.showAlert('error', $translate.instant('CORPORATIVO.VALIDACAO.REGISTRO_BLOQUEADO_NAO_PODE_SER_ALTERADO'));
			return;
		}

		$scope.formPessoa.$submitted = true;
			//Vefifica se o formPessoa está invalido, caso esteja envia um alerta para o usuario
		    	validarErroFomContato();
			if($scope.formPessoa.$invalid){

				$scope.showAlert('error', $translate.instant('MSG.MN001'));

			}else{

				if($scope.colaborador.estruturaOrganizacional){
					delete $scope.colaborador.estruturaOrganizacional.classificacao;
					delete $scope.colaborador.estruturaOrganizacional.organizacao;
				}

				var pessoaVH = {

						pessoa       						: $scope.pessoa,
						colaborador  						: $scope.colaborador,
						orgaoExterno 						: $scope.orgaoExterno,
						portador     						: $scope.portador,
						fornecedor   						: $scope.fornecedor,
						seguradora							: $scope.seguradora,
						terceirizado						: $scope.terceirizado,
						dominiosTipoParceiroSelecionados    : $scope.dominiosTipoParceiroSelecionados
				};

				 $scope.pessoa.parceiros = null;

				 $scope.setLoadingSalva(true);

				 PessoaRepository.save(pessoaVH).then(function(result) {

					 $scope.pessoa = result.originalElement;

					 $scope.apresentarBotaoBloquear = !$scope.pessoa.dataBloqueio;

					 $scope.dominiosTipoParceiroSelecionados = [];
					//Percorre a lista de parceiros vinculados a pessoa para montar na tela.
					angular.forEach($scope.pessoa.parceiros, function(parceiro) {

							$scope.adicionarParceiroEdicao(parceiro);

						});

					 $scope.setLoading(false);
					 $scope.showAlert("success",  $translate.instant('MSG.MG001'));
					 $scope.resetForm();
				});

			}

	};

	//Método responsável por desbloquear a pessoa
	$scope.desbloquearPessoa = function(){

		$scope.pessoa.dataBloqueio = null;

		$scope.saveOrUpdate();

	};

	//Método responsável por obter a Pessoa
	$scope.getPessoa = function(id, visualizar){

		$scope.formPessoa.$submitted = false;

		$scope.setLoadingGet(true);

		$scope.resetForm();

		$scope.edit = true;
		$timeout(function(){
			PessoaRepository.get(id).then(function(result) {

				$scope.pessoa = result.originalElement;

				$scope.isVisualizar = visualizar;

				$scope.apresentarBotaoBloquear = !$scope.pessoa.dataBloqueio;

				$scope.setLoading(false);
				//Percorre a lista de parceiros vinculados a pessoa para montar na tela.
				angular.forEach($scope.pessoa.parceiros, function(parceiro) {

					$scope.adicionarParceiroEdicao(parceiro);

				});
			});
		});
	};
	//Método responsável por adicionar o parceiro na tela de edição
	$scope.adicionarParceiroEdicao = function(parceiro){
		//Vefifica se o parceiro é do tipo colaborador
		if(parceiro.classeParceiro.dominioTipoParceiro.codigo == 1){

			$scope.apresentarColaborador = true;

			$scope.colaborador = parceiro;
		//Vefifica se o parceiro é do tipo orgaoExterno
		}else if(parceiro.classeParceiro.dominioTipoParceiro.codigo == 2){

			$scope.apresentarOrgaoExterno = true;

			$scope.orgaoExterno = parceiro;
		//Verifica se o parceiro é do tipo portador
		}else if(parceiro.classeParceiro.dominioTipoParceiro.codigo == 3){

			$scope.apresentarPortador = true;

			$scope.portador = parceiro;
		//Verifica se o parceiro é do tipo fornecedor
		}else if(parceiro.classeParceiro.dominioTipoParceiro.codigo == 4){

			$scope.apresentarFornecedor = true;

			$scope.fornecedor = parceiro;

			// Seguradora
		}else if(parceiro.classeParceiro.dominioTipoParceiro.codigo == 5){

			$scope.apresentarSeguradora = true;

			$scope.seguradora = parceiro;

			// Terceirizado
		} else if(parceiro.classeParceiro.dominioTipoParceiro.codigo == 6){

			$scope.apresentarTerceirizado = true;

			$scope.terceirizado = parceiro;

		} 
		
		$scope.dominiosTipoParceiroSelecionados.push(parceiro.classeParceiro.dominioTipoParceiro);

		$scope.tiposParceiro = $filter('idNotEqualDominio')($scope.tiposParceiro, $scope.dominiosTipoParceiroSelecionados);

	};

	//Método responsável por limpar os dados da Pessoa
	$scope.resetForm = function() {

		$scope.isVisualizar = false,

		$scope.findAllDominioTipoParceiro();
		
		$scope.dominiosTipoParceiroSelecionados = [];

		$scope.dominioTipoParceiro = {};
		
		apresentarTabFalse();

		$scope.colaborador = {};

		$scope.orgaoExterno = {};

		$scope.portador = {};

		$scope.fornecedor = {};

		$scope.seguradora = {};

		$scope.contato = {};

		$scope.pessoa = {

				telefones : [],

				enderecos : [],

				contatos : [],
		};

		$timeout(function(){
			$scope.formPessoa.$submitted = false;
			$scope.formPessoa.$setPristine();

			if($scope.formPessoa['endereco.cep']) {
				$scope.formPessoa['endereco.cep'].$setViewValue('');
				$scope.formPessoa['endereco.cep'].$render();
			}

			if($scope.formPessoa['endereco.complemento']) {
				$scope.formPessoa['endereco.complemento'].$setViewValue('');
				$scope.formPessoa['endereco.complemento'].$render();
			}

			if($scope.formPessoa['endereco.logradouro']) {
				$scope.formPessoa['endereco.logradouro'].$setViewValue('');
				$scope.formPessoa['endereco.logradouro'].$render();
			}
			if($scope.formPessoa['endereco.numero']) {
				$scope.formPessoa['endereco.numero'].$setViewValue('');
				$scope.formPessoa['endereco.numero'].$render();
			}

			if($scope.formPessoa['pais']) {
				$scope.formPessoa['pais'].$setViewValue('');
				$scope.formPessoa['pais'].$render();
			}

			if($scope.formPessoa['regiao']) {
				$scope.formPessoa['regiao'].$setViewValue('');
				$scope.formPessoa['regiao'].$render();
			}

			if($scope.formPessoa['estado']) {
				$scope.formPessoa['estado'].$setViewValue('');
				$scope.formPessoa['estado'].$render();
			}

			if($scope.formPessoa['cidade']) {
				$scope.formPessoa['cidade'].$setViewValue('');
				$scope.formPessoa['cidade'].$render();
			}
			if($scope.formPessoa['bairro']) {
				$scope.formPessoa['bairro'].$setViewValue('');
				$scope.formPessoa['bairro'].$render();
			}
			if($scope.formPessoa['telefone.numero']) {
				$scope.formPessoa['telefone.numero'].$setViewValue('');
				$scope.formPessoa['telefone.numero'].$render();
			}

			if($scope.formPessoa['pessoa.email']) {
				$scope.formPessoa['pessoa.email'].$setViewValue('');
				$scope.formPessoa['pessoa.email'].$render();
			}

		});
	};
	
	//Método responsável por adicionar parceiro
	$scope.adicionarParceiro = function(dominioTipoParceiro){
		//Vefifica se o parceiro é do tipo colaborador
		if(dominioTipoParceiro.codigo == 1){

			$scope.apresentarColaborador = true;

			$scope.colaborador = {};
			
			$scope.activeOrgaoExterno = false;
			$scope.activePortador = false;
			$scope.activeFornecedor = false;
			$scope.activeSeguradora = false;
			$scope.activeTerceirizado = false;
			$scope.activeColaborador = true;

		//Vefifica se o parceiro é do tipo orgaoExterno
		}else if(dominioTipoParceiro.codigo == 2){

			$scope.apresentarOrgaoExterno = true;

			$scope.orgaoExterno = {};

			$scope.activeColaborador = false;
			$scope.activePortador = false;
			$scope.activeFornecedor = false;
			$scope.activeSeguradora = false;
			$scope.activeTerceirizado = false;
			$scope.activeOrgaoExterno = true;

		//Vefifica se o parceiro é do tipo portador
		}else if(dominioTipoParceiro.codigo == 3){

			$scope.apresentarPortador = true;

			$scope.portador = {};

			$scope.activeColaborador = false;
			$scope.activeOrgaoExterno = false;
			$scope.activeFornecedor = false;
			$scope.activeSeguradora = false;
			$scope.activeTerceirizado = false;
			$scope.activePortador = true;

		//Vefifica se o parceiro é do tipo fornecedor
		}else if(dominioTipoParceiro.codigo == 4){

			$scope.apresentarFornecedor = true;

			$scope.fornecedor = {};

			$scope.activeColaborador = false;
			$scope.activeOrgaoExterno = false;
			$scope.activePortador = false;
			$scope.activeSeguradora = false;
			$scope.activeTerceirizado = false;
			$scope.activeFornecedor = true;

			// Seguradora
		}else if (dominioTipoParceiro.codigo == 5){

			$scope.apresentarSeguradora = true;

			$scope.seguradora = {};

			$scope.activeColaborador = false;
			$scope.activeOrgaoExterno = false;
			$scope.activePortador = false;
			$scope.activeFornecedor = false;
			$scope.activeTerceirizado = false;
			$scope.activeSeguradora = true;
			
			// Terceirizado
		} else if (dominioTipoParceiro.codigo == 6){

			$scope.apresentarTerceirizado = true;

			$scope.terceirizado = {};

			$scope.activeColaborador = false;
			$scope.activeOrgaoExterno = false;
			$scope.activePortador = false;
			$scope.activeFornecedor = false;
			$scope.activeSeguradora = false;
			$scope.activeTerceirizado = true;
			
		} 
 		
		//Verifica se o dominioTipoParceiro contem o originalElement
		if(dominioTipoParceiro.originalElement){

			$scope.dominiosTipoParceiroSelecionados.push(dominioTipoParceiro.originalElement);
		}else{

			$scope.dominiosTipoParceiroSelecionados.push(dominioTipoParceiro);
		}

		$scope.tiposParceiro = $filter('idNotEqualDominio')($scope.tiposParceiro, $scope.dominiosTipoParceiroSelecionados);

		$scope.dominioTipoParceiro = {};

		dominioTipoParceiro = {};

		$scope.formPessoa.$submitted = false;

	};

	// Método responsável por remove o parceiro através do codigo selecionado
	$scope.removerParceiro = function(){

		angular.forEach($scope.dominiosTipoParceiroSelecionados, function(dominioTipoParceiro) {
			//Verifica se o codigo do parceiro é igual ao codigoParceiroRemocao
			if(dominioTipoParceiro.codigo == $scope.codigoParceiroRemocao){
				//Verifica se o dominioTipoParceiro contem o originalElement
				if(dominioTipoParceiro.originalElement){

					$scope.dominiosTipoParceiroSelecionados.splice(($scope.dominiosTipoParceiroSelecionados.indexOf(dominioTipoParceiro.originalElement)), 1);
				}else{

					$scope.dominiosTipoParceiroSelecionados.splice(($scope.dominiosTipoParceiroSelecionados.indexOf(dominioTipoParceiro)), 1);

				}

				$scope.tiposParceiro.push(dominioTipoParceiro);

				$scope.removerAbaParceiro();

				$scope.removerEntidadeParceiro(dominioTipoParceiro);
				
				activeTabDefault();
			}
		});

		$scope.$modalConfirmInstance.dismiss('cancel');
	};
	
	function activeTabDefault() {
		$scope.activeColaborador = false;
		$scope.activeOrgaoExterno = false;
		$scope.activePortador = false;
		$scope.activeFornecedor = false;
		$scope.activeSeguradora = false;
		$scope.activeTerceirizado = false;
		if($scope.apresentarColaborador) {
			$scope.activeColaborador = true;
		} else if($scope.apresentarOrgaoExterno) {
			$scope.activeOrgaoExterno = true;
		} else if($scope.apresentarPortador) {
			$scope.activePortador = true;
		} else if($scope.apresentarFornecedor) {
			$scope.activeFornecedor = true;
		} else if($scope.apresentarSeguradora) {
			$scope.activeSeguradora = true;
		} else if($scope.apresentarTerceirizado) {
			$scope.activeTerceirizado = true;
		}
	}

	// Método responsável por realizar a exclusão da entidade parceiro
	$scope.removerEntidadeParceiro = function(dominioTipoParceiro){
		//Vefifica se o dominioTipoParceiro é do tipo colaborador e se o colaborador contem id
		if(dominioTipoParceiro.codigo == 1 && $scope.colaborador.id){

			PessoaRepository.removeColaborador($scope.colaborador.id).then(function(result) {

				$scope.colaborador = {};

			});
		// Vefifica se o dominioTipoParceiro é do tipo orgaoExterno e se o orgaoExterno contem id
		}else if(dominioTipoParceiro.codigo == 2 && $scope.orgaoExterno.id){

			PessoaRepository.removeOrgaoExterno($scope.orgaoExterno.id).then(function(result) {

			});
		// Vefifica se o dominioTipoParceiro é do tipo portador e se o portador contem id
		}else if(dominioTipoParceiro.codigo == 3 && $scope.portador.id){

			PessoaRepository.removePortador($scope.portador.id).then(function(result) {

			});
		// Vefifica se o dominioTipoParceiro é do tipo fornecedor e se o fornecedor contem id
		}else if(dominioTipoParceiro.codigo == 4 && $scope.fornecedor.id){

			PessoaRepository.removeFornecedor($scope.fornecedor.id).then(function(result) {

				$scope.fornecedor = {};

			});

		}else if(dominioTipoParceiro.codigo == 5 && $scope.seguradora.id){

			PessoaRepository.removeSeguradora($scope.seguradora.id).then(function(result) {

				$scope.seguradora = {};

			});

		} else if(dominioTipoParceiro.codigo == 6 && $scope.terceirizado.id){

			PessoaRepository.removeTerceirizado($scope.terceirizado.id).then(function(result) {

				$scope.terceirizado = {};

			});

		}


	};

	//Método responsável por remover a aba de parceiro através do codigo do dominioTipoParceiro selecionado.
	$scope.removerAbaParceiro = function(){
		//Verifica se o codigoRemocao é referente ao Colaborador
		if($scope.codigoParceiroRemocao == 1){

			$scope.apresentarColaborador = false;
			$scope.activeColaborador = false;

		//Verifica se o codigoRemocao é referente ao OrgaoExterno
		}else if($scope.codigoParceiroRemocao == 2){

			$scope.apresentarOrgaoExterno = false;
			$scope.activeOrgaoExterno = false;
		//Verifica se o codigoRemocao é referente ao Portador
		}else if($scope.codigoParceiroRemocao == 3){

			$scope.apresentarPortador = false;
			$scope.activePortador = false;
		//Verifica se o codigoRemocao é referente ao Fornecedor
		}else if($scope.codigoParceiroRemocao == 4){

			$scope.apresentarFornecedor = false;
			$scope.activeFornecedor = false;
			//Seguradora
		}else if($scope.codigoParceiroRemocao == 5){

			$scope.apresentarSeguradora = false;
			$scope.activeSeguradora = false;
			//Terceirizado
		}else if($scope.codigoParceiroRemocao == 6){

			$scope.apresentarTerceirizado = false;
			$scope.activeTerceirizado = false;
		}

	};

	// Método responsável por listar as funcoes através do nome
	$scope.findFuncao =  function(value){
		   return FuncaoRepository.findFuncaoPorOrganizacao(value, $scope.usuarioLogado.organizacao.id).then(function(result) {
			   return result;
		   });
		};

	// FORNECEDOR

	//Método responsável por editar observacao
	$scope.editObservacao = function(){

		angular.forEach($scope.fornecedor.observacoes, function(observacao, index) {

			if(observacao.$checked){

				$scope.fornecedorObservacao = observacao;

				$scope.fornecedorObservacao.$edit = true;
			}
		});

	};

	// Método responsável por adicionar observação
	$scope.adicionarObservacaoFornecedor = function(){
		//Verifica se a observacao do fornecedor não está vazia ou null
		 if(!$scope.fornecedor.observacoes){

			 $scope.fornecedor.observacoes = [];

		 }
		 //Verifica se o fornecedorObservacao não está sendo editado
		 if(!$scope.fornecedorObservacao.$edit){

			 var fornecedorObservacaoTemp = {};

			 angular.copy($scope.fornecedorObservacao, fornecedorObservacaoTemp);

			 $scope.fornecedor.observacoes.push(fornecedorObservacaoTemp);

		 }

		 $scope.fornecedorObservacao = {};

		 $scope.fornecedorObservacao.$edit = false;

	};
	//Método responsavel por selecionar a observacao
	$scope.checkObservacao = function (observacao) {

		$scope.removeCheckedObservacao();

		observacao.$checked = true;

	};
	//Método responsável por setar false em todos os $checked da observacao
	$scope.removeCheckedObservacao = function () {
		var observacoes = $scope.fornecedor.observacoes;

		observacoes.forEach(function (observacao) {
			observacao.$checked = false;
		});
	};
	//Método responsável por apresentar o dialog de confirmação de remoção da observacao
	$scope.apresentarDialogConfirmacaoRemocaoObservacao = function(){

		$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerObservacao});
	};

	// Método responsável por remover observacaoFornecedor
	$scope.removerObservacao = function(){

		angular.forEach($scope.fornecedor.observacoes, function(observacao, index) {
			//Verifica se a observacao está selecionada
			if(observacao.$checked){

				if(observacao.id){

					PessoaRepository.removeFornecedorObservacao(observacao.id).then(function(result) {

					});
				}

				$scope.fornecedor.observacoes.splice(index , 1);
			}
		});

		 $scope.$modalConfirmInstance.dismiss('cancel');
	};

	//Método responsavel por listar classificacaoMaterial do tipo Grupo
	$scope.findGrupo =  function(value){
		var restAngular = $injector.get(["ClassificacaoMaterialRepository"]);
		return restAngular.listarClassificacaoMaterial(value, 1).then(function(result) {
			return result;
		});
	};

	// Método responsável por classificacaoMaterial do tipo SubGrupo
	$scope.findSubGrupo =  function(value){
		var restAngular = $injector.get(["ClassificacaoMaterialRepository"]);
		return restAngular.listarFilhosPorDescricaoIdParent(value, $scope.fornecedorRamoAtividade.grupoFederalSupply.id).then(function(result) {
			return   $filter('idNotEqualClassificacaoMaterial')(result, $scope.fornecedor.fornecedorRamoAtividades);;
		});
	};

   //Método responsável por adicionar RamoAtividade
   $scope.adicionarRamoAtividade = function(){
	   //Vefifica se o fornecedorRamoAtividade contem o subGrupoFederalSupply
	   if($scope.fornecedorRamoAtividade.subGrupoFederalSupply){
		   //Verifica se a lista de fornecedorRamosAtividades não é null ou vazia
		   if(!$scope.fornecedor.fornecedorRamoAtividades){

			   $scope.fornecedor.fornecedorRamoAtividades = [];

		   }

			 var fornecedorRamoAtividadeTemp = {};

			 angular.copy($scope.fornecedorRamoAtividade, fornecedorRamoAtividadeTemp);

			 $scope.fornecedor.fornecedorRamoAtividades.push(fornecedorRamoAtividadeTemp);

			 $scope.fornecedorRamoAtividade = {};

	   }

   };
	//Método responsável por setar true no ramoAtividade selecionado
	$scope.checkRamoAtividade = function (ramoAtividade) {

		$scope.removeCheckedRamoAtividade();

		ramoAtividade.$checked = true;
	};
	//Método responsável por setar false em todos os ramoAtividade
	$scope.removeCheckedRamoAtividade = function () {
		var ramoAtividades =  $scope.fornecedor.fornecedorRamoAtividades;

		ramoAtividades.forEach(function (ramoAtividade) {
			ramoAtividade.$checked = false;
		});
	};

	//Método responsável por setar contato a ser excluido
	$scope.apresentarDialogConfirmacaoRemocaoRamoAtividade = function(){

		$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerFornecedorRamoAtividade});
	};

   //Método responsável por remover o fornecedorRamoAtividade
	$scope.removerFornecedorRamoAtividade = function(){
		//Percorre a lista de fornecedorRamoAtividades para encontrar  ramoAtividade selecionado
		angular.forEach($scope.fornecedor.fornecedorRamoAtividades, function(ramoAtividade, index) {
			//Verifica se o ramoAtividade está selecionado
			if(ramoAtividade.$checked){

				if(ramoAtividade.id){

					PessoaRepository.removeFornecedorRamoAtividade(ramoAtividade.id).then(function(result) {

					});
				}

				$scope.fornecedor.fornecedorRamoAtividades.splice(index , 1);
			}

		});

		 $scope.$modalConfirmInstance.dismiss('cancel');

	};

	// FIM FORNECEDOR

	//CONTATO

	//Método responsável por adicionar contato
	$scope.adicionarContato = function(){
		 //Verifica se a lista de contatos da pessoa não é null ou vazia
		 if(!$scope.pessoa.contatos){
			$scope.pessoa.contatos = [];
		 }

		 if ($scope.existeRepresentanteLegal() && $scope.contato.representanteLegal === true){
			 $scope.showAlert('error', $translate.instant('CORPORATIVO.VALIDACAO.REPRESENTANTE_LEGAL_UNICO'));
			 return
		 }

		 if ($scope.contato.representanteLegal === true){
			 if (!$scope.contato.cpf){
				 $scope.showAlert('error', $translate.instant('CORPORATIVO.VALIDACAO.CPF_OBRIGATORIO_REPRESENTANTE_LEGAL'));
				 return
			 }
		 }

		 if (!CPF.isValid($scope.contato.cpf)) {
			 $scope.showAlert('error', $translate.instant('CORPORATIVO.VALIDACAO.CPF_INVALIDO_CONTATO'));
			 return;
		 }

		 //Vefifica se o nome do contato foi informado pelo usuario
		 if($scope.contato.nome){

			 $scope.nomeInvalid = false;
			 //Verifica se o contato está sendo editado.
			 if(!$scope.contato.$edit){

				 var contatoTemp = {};

				 angular.copy($scope.contato, contatoTemp);

				 $scope.pessoa.contatos.push(contatoTemp);
			 }

			 $scope.contato = {};

			 $scope.contato.$edit = false;
		 }else{
			 $scope.nomeInvalid = true;

		 }

	};

	//Método responsável por ver se alguns dos contatos já é representante legal, visto que somente um pode ser marcado como representante Legal
	$scope.existeRepresentanteLegal = function(){
		var result = false;
		angular.forEach($scope.pessoa.contatos, function(contato, index) {
			if (contato.representanteLegal){
				result = true;
			};

		});
		return result;
	};

	//Método responsável por setar contato a ser excluido
	$scope.apresentarDialogConfirmacaoRemocaoContato = function(){
        	var itemChecked = $scope.pessoa.contatos.some(function(item){
        		return item.$checked;
	        });
	        if(itemChecked)
	           $scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerContato});
        	else 
	           $scope.showAlert("warning", $translate.instant("LABEL.SELECIONE_UM_ITEM"));
	};
	//setar true no contato selecionado
	$scope.checkContato = function (contato) {

		$scope.removeCheckedContato();

		contato.$checked = true;
	};
	//Método responsável por setar false em todos os $checked
	$scope.removeCheckedContato = function () {
		var contatos =  $scope.pessoa.contatos;

		contatos.forEach(function (contato) {
			contato.$checked = false;
		});
	};

	//Método responsável por remover contato
	$scope.removerContato = function(){
		//Percorre a lista de contatos para encontrar o contato selecionado para remoção.
		angular.forEach($scope.pessoa.contatos, function(contato, index) {
			//Verifica se o contato foi selecionado
			if(contato.$checked){

				if(contato.id){

					PessoaRepository.removeContato(contato.id).then(function(result) {

					});
				}

				$scope.pessoa.contatos.splice(index , 1);
			}

		});

		 $scope.$modalConfirmInstance.dismiss('cancel');

	};


	//Método responsável por setar contato a ser excluido
	$scope.apresentarDialogConfirmacaoRemocaoParceiro = function(codigoParceiro){

		$scope.codigoParceiroRemocao = codigoParceiro;

		$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerParceiro});
	};
	//Método responsável por apresentar o dialog de confirmação de remoção de pessoa
	$scope.apresentarDialogConfirmacaoRemocaoPessoa = function(){

		$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerPessoa});
	};

	//Método responsável por habilitar os campos e botão para editar os dados.
	$scope.habilitarSalvar = function(){

		$scope.isVisualizar = false;
	};

	$scope.fetchResult = function(){
		angular.element('#searchPessoa').scope().fetchResult();
	};

	$scope.findUsuario = function(value) {
		return UsuarioRepository.findByUsername(value).then(function(result) {
			return result;
		});
	};

	$scope.setUsuario = function (item) {
		if(item && item.id) {
			$scope.pessoa.usuario = item;
		}
	};

	$scope.limparUsuario = function () {
		$scope.pessoa.usuario = null;
	};
	
	$scope.findFornecedor = function(value){
		return FornecedorRepository.listarFornecedoresBusca(value).then(function(result){
			return result;
		});
	};

}]);