'use strict';
citApp.controller('PessoaListController',['$scope', 'PessoaRepository', 'DominioRepository', '$translate', '$timeout', function PessoaListController($scope, PessoaRepository, DominioRepository, $translate, $timeout) {
	$scope.$showAdvancedFilters = false;

	$scope.headers = [ {
		title : $translate.instant('CORPORATIVO.LABEL.TIPO_PESSOA'),
		value : 'dominioPessoa.descricao'
	}, {
		title : $translate.instant('LABEL.NOME'),
		value : 'nome'
	}, {
		title : $translate.instant('LABEL.CPF_CNPJ'),
		value : 'cpfCnpj',
		notSort: true
	}];

	// Iniciar propriedades padrão da consulta que sera enviada para o servidor.
	$scope.filterCriteria = {
		start : 1,
		dir : 'asc',
		sort : 'id',
		limit : 10,
		fields : [ 'id', 'dominioPessoa.descricao', 'nome', 'pessoaFisica.cpf', 'pessoaJuridica.cnpj'],
		filters : [ {
			type : 'string',
			field : 'dominioPessoa.descricao'
		}, {
			type : 'string',
			field : 'nome'
		}, {
			type : 'string',
			field : 'cpfCnpj',
		}]
	};

	$scope.abrirPessoa = function(visualizar, workspace){

		var pessoa = $scope.pessoaChecked;

		if(!pessoa) {
			$scope.showAlert('warning', visualizar ?  $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));

			return;
		}

		if($scope.pessoaChecked.dataBloqueio){
			$scope.showAlert('error', $translate.instant('CORPORATIVO.VALIDACAO.REGISTRO_BLOQUEADO_NAO_PODE_SER_ALTERADO'));

			return;
		}

		$scope.$showPageEditWorkspace(workspace);
		angular.element('#pessoaEdit').scope().getPessoa(pessoa.id, visualizar);

	};

}]);