'use strict';

citApp.controller('UnidadeMedidaController', ['$scope', 'UnidadeMedidaRepository', '$translate', '$timeout', 'DominioRepository',
		function UnidadeMedidaController($scope, UnidadeMedidaRepository, $translate, $timeout, DominioRepository) {

	$scope.showInteiro= true;

    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.limparUnidadeMedida();
        $scope.edit = true;
        $timeout(function(){
            $scope.unidadeMedidaForm.$submitted = false;
            $scope.unidadeMedidaForm.$setPristine();
        });
    };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchUnidadeMedida').scope().fetchResult();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(unidadeMedida){
        $scope.unidadeMedida = unidadeMedida;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                UnidadeMedidaRepository.remove($scope.unidadeMedida).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchUnidadeMedida').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O UnidadeMedida
    $scope.saveOrUpdate = function(){
        $scope.unidadeMedidaForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.unidadeMedidaForm.$valid){

            $scope.setLoadingSalva(true);

            UnidadeMedidaRepository.save($scope.unidadeMedida).then(function(result) {
                $scope.unidadeMedida = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
                $scope.unidadeMedidaForm.$submitted = false;
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
            $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
        }
    };

    // Limpa o formulario preenchido
    $scope.limparUnidadeMedida = function(){
        $scope.unidadeMedida = {};
    };

    // Consulta entidade e mostra no formulario
    $scope.getUnidadeMedida = function(unidadeMedida, edit){
        $scope.setLoadingGet(true);

        UnidadeMedidaRepository.get(unidadeMedida.id).then(function(result) {
            $scope.unidadeMedida = result.originalElement;
            $scope.edit = edit;
            $scope.setLoading(false);
            $scope.alternaTipoNumerico();
        });
        
    };

    DominioRepository.findAllDominio('tipoNumerico').then(function(result) {
        $scope.tipoNumericoList = result;
    });

    $scope.atualizaCampoQTDEPadrao = function(){
    	$scope.unidadeMedida.quantidadePadrao;
    };

    $scope.alternaTipoNumerico = function(){
    	$timeout(function(){
    		if($scope.unidadeMedida.tipoNumerico){
    			$scope.defineTipoNumerico();
    		}else{
    			$scope.showInteiro= true;
    			$scope.unidadeMedida.quantidadeInteiro = '';
    			$scope.unidadeMedida.quantidadeDecimal = '';
    		}
    	});
    };
    $scope.defineTipoNumerico = function(){
    	switch($scope.unidadeMedida.tipoNumerico.codigo){
			case 1:
				$scope.showInteiro= true;
				$scope.showDecimal = false;
				$scope.unidadeMedida.quantidadeDecimal = '';
			break;
	
			case 2:
				$scope.showDecimal = true;
				$scope.showInteiro= false;
				$scope.unidadeMedida.quantidadeInteiro = '';
			break;
		}
    };
}]);