'use strict';

citApp.controller('UnidadeMedidaListController', ['$scope', 'UnidadeMedidaRepository', '$translate', '$timeout', 'DominioRepository',
		function UnidadeMedidaListController($scope, UnidadeMedidaRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editUnidadeMedida").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.CODIGO'), value : 'codigo' } ,
                       {title : $translate.instant('LABEL.DESCRICAO'), value : 'descricao' } ,
                       {title : $translate.instant('CORPORATIVO.LABEL.TIPO_NUMERICO'), value : 'tipoNumerico.descricao' } ,
                       {title : $translate.instant('LABEL.SIGLA'), value : 'sigla' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'codigo', 'descricao', 'tipoNumerico.descricao', 'sigla'],
        filters : [ {type : 'string', field : 'codigo'} ,
                    {type : 'string', field : 'descricao'} ,
                    {type : 'string', field : 'tipoNumerico.descricao', listaDominio : [] } ,
                    {type : 'string', field : 'sigla' }]
    };

    DominioRepository.findAllDominio('tipoNumerico').then(function(result) {
        $scope.filterCriteria.filters[2].listaDominio = result;
    });

    // ABRI UnidadeMedida SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var unidadeMedida = $scope.unidadeMedidaChecked;

        if(!unidadeMedida) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editUnidadeMedida').scope().getUnidadeMedida(unidadeMedida, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
