package br.com.centralit.controller.impl;

import java.util.ArrayList;
import java.util.List;

import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.web.WebAppConfiguration;

import br.com.centralit.api.dao.AlcadaDao;
import br.com.centralit.api.model.Alcada;
import br.com.centralit.api.service.AlcadaService;
import br.com.centralit.controller.AlcadaController;
import br.com.centralit.framework.model.Filter;
import br.com.centralit.framework.model.SearchParams;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 23/06/2015 - 11:20:40
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@WebAppConfiguration
@ContextConfiguration("/spring/applicationContext-test.xml")
@RunWith(SpringJUnit4ClassRunner.class)
public class AlcadaControllerTest extends GenericControllerTestImpl<Alcada> {

    @Mock
    private AlcadaController alcadaController;

    @Autowired
    private AlcadaService alcadaService;

    @Autowired
    private AlcadaDao alcadaDao;

    @Override
    protected void initMocks() {
        MockitoAnnotations.initMocks(this);
    }

    @Override
    protected String getRequestMapping() {
        return "/rest/alcada";
    }

    @Override
    protected SearchParams getSearchParams() {
        SearchParams searchParams = new SearchParams();
        return montaSearchParams(searchParams);
    }

    private SearchParams montaSearchParams(SearchParams searchParams) {
        searchParams.setDir("asc");
        searchParams.setFields(montaFields());
        searchParams.setFilters(montaFilters());
        searchParams.setLimit(10);
        searchParams.setStart(1);
        return searchParams;
    }

    private List<String> montaFields() {
        List<String> fields = new ArrayList<String>();
        fields.add(0, "id");
        return fields;
    }

	private List<Filter> montaFilters() {
		List<Filter> filters = new ArrayList<Filter>();
		return filters;
	}

    @Override
    public void getObjectTest() throws Exception {
        // TODO implementar para teste do metodo getObject do GenericController
    }
}
