package br.com.centralit.controller.impl;

import java.util.ArrayList;
import java.util.List;

import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.web.WebAppConfiguration;

import br.com.centralit.api.dao.CentroCustoDao;
import br.com.centralit.api.model.CentroCusto;
import br.com.centralit.api.service.CentroCustoService;
import br.com.centralit.controller.CentroCustoController;
import br.com.centralit.framework.model.Filter;
import br.com.centralit.framework.model.SearchParams;

@WebAppConfiguration
@ContextConfiguration("/spring/applicationContext-test.xml")
@RunWith(SpringJUnit4ClassRunner.class)
public class CentroCustoControllerTest extends GenericControllerTestImpl<CentroCusto> {

    @Mock
    private CentroCustoController centroCustoController;

    @Autowired
    private CentroCustoService centroCustoService;

    @Autowired
    private CentroCustoDao centroCustoDao;

    @Override
    protected void initMocks() {
        MockitoAnnotations.initMocks(this);
    }

    @Override
    protected String getRequestMapping() {
        return "/rest/centroCusto";
    }

    @Override
    protected SearchParams getSearchParams() {
        SearchParams searchParams = new SearchParams();
        return montaSearchParams(searchParams);
    }

    private SearchParams montaSearchParams(SearchParams searchParams) {
        searchParams.setDir("asc");
        searchParams.setFields(montaFields());
        searchParams.setFilters(montaFilters());
        searchParams.setLimit(10);
        searchParams.setStart(1);
        return searchParams;
    }

    private List<String> montaFields() {
        List<String> fields = new ArrayList<String>();
        fields.add(0, "id");
        return fields;
    }

	private List<Filter> montaFilters() {
		List<Filter> filters = new ArrayList<Filter>();
		return filters;
	}

    @Override
    public void getObjectTest() throws Exception {
        // TODO implementar para teste do metodo getObject do GenericController
    }
}
