﻿CREATE INDEX codigo_entrada ON PUBLIC.entrada (codigo);
CREATE INDEX codigo_estrutura ON PUBLIC.ESTRUTURAORGANIZACIONAL (codigo);

CREATE INDEX codigo_entrada_estrutura ON PUBLIC.entradapatrimonio (ESTRUTURAORGANIZACIONAL_ID);
CREATE INDEX codigo_estrutura_id ON PUBLIC.ESTRUTURAORGANIZACIONAL (ID);

CREATE UNIQUE INDEX codigo_bem ON PUBLIC.BEMPATRIMONIAL (codigo);
CREATE UNIQUE INDEX codigo_conta ON PUBLIC.CONTACONTABIL (codigo);

--TRUNCATE PUBLIC.DOMINIO CASCADE;
--TRUNCATE  public.ESTRUTURAORGAO CASCADE;

-- CARGA NA TABELA PAIS
INSERT INTO public.pais
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	NOME,
	SIGLA
)
SELECT
	PAIS.ID_PAIS,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	PAIS.CD_PAIS,
	PAIS.NM_PAIS,
	PAIS.NM_SIGLA_PAIS

FROM ASIWEB.CR_PAIS PAIS
ORDER BY PAIS.ID_PAIS;

-- CARGA NA TABELA REGIAO
INSERT INTO public.regiao
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	NOME,
	PAIS_ID
)
SELECT
	REGIAO.ID_REGIAO_UF,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	REGIAO.CD_REGIAO,
	REGIAO.NM_REGIAO,
	1

FROM ASIWEB.CR_REGIAO_UF REGIAO
ORDER BY REGIAO.ID_REGIAO_UF;

-- CARGA NA TABELA ESTADO
INSERT INTO public.estado
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	NOME,
	SIGLA,
	REGIAO_ID
)
SELECT
	ESTADO.ID_UF,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	ESTADO.CD_UF,
	ESTADO.NM_UF,
	ESTADO.NM_SIGLA_UF,
	1 -- arrumar cadastro

FROM ASIWEB.CR_UF ESTADO
ORDER BY ESTADO.ID_UF;

-- CARGA NA TABELA CIDADE
INSERT INTO public.cidade
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	CODIGOIBGE,
	NOME,
	ESTADO_ID
)
SELECT
	CIDADE.ID_CIDADE,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	CIDADE.CD_CIDADE,
	CIDADE.CD_IBGE,
	CIDADE.NM_CIDADE,
	(SELECT ESTADO.ID_UF FROM ASIWEB.CR_UF ESTADO WHERE ESTADO.CD_UF = CIDADE.CD_UF)
FROM ASIWEB.CR_CIDADE CIDADE
ORDER BY CIDADE.CD_CIDADE;

-- CADASTRO DE UM BAIRRO PADRÃO
INSERT INTO public.bairro
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	NOME,
	CIDADE_ID
)
SELECT
	1,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	1,
	'bairro padrão',
	CIDADE.ID_CIDADE
FROM ASIWEB.CR_CIDADE CIDADE
WHERE CIDADE.ID_CIDADE = 2;

-- CARGA NA TABELA ENDERECO
INSERT INTO public.endereco
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CEP,
	CODIGO,
	COMPLEMENTO,
	LOGRADOURO,
	NOME,
	NUMERO,
	BAIRRO_ID,
	CIDADE_ID
)
SELECT
	ENDERECO.ID_INSTALACAO,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	ENDERECO.NR_CEP,
	ENDERECO.CD_INSTALACAO,
	'',
	ENDERECO.DS_ENDERECO,
	ENDERECO.NM_INSTALACAO,
	NULL,
	1,
	(SELECT CIDADE.ID_CIDADE FROM ASIWEB.CR_CIDADE CIDADE WHERE CIDADE.CD_CIDADE = ENDERECO.CD_CIDADE)
FROM ASIWEB.CR_INSTALACAO ENDERECO
ORDER BY ENDERECO.CD_INSTALACAO;

-- CRIA O MAPA ORGANIZACIONAL UMA CONFIGURACAO E UMA LOCALIZAÇÃO PARA PODER CADASTRAR A ESTRUTURA INICIAL
-- MAPA ORGANIZACIONAL
INSERT INTO mapaorganizacional(id, datacriacao, dataedicao, version, datainicio, nome)
  VALUES (0, TO_DATE('2015-01-01 10:26:27','YYYY-MM-DD HH24:MI:SS'), TO_DATE('2015-01-01 10:26:27','YYYY-MM-DD HH24:MI:SS'), 0, TO_DATE('2014-12-23','YYYY-MM-DD'), 'Mapa Organizacional 1');

-- LOCALIZACAO
INSERT INTO localizacao(id, datacriacao, dataedicao, version, nome, endereco_id, codigo)
    VALUES (0, '2014-11-20', '2014-11-20', 1, 'Mpog', 1, 'LOC0001');

-- CARGA NA TABELA LOCALIZAÇÃO
INSERT INTO public.localizacao
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	NOME
)
SELECT
	LOCALIZACAO.ID_LOCALIZ,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	LOCALIZACAO.CD_LOCAL,
	LOCALIZACAO.NM_LOCAL
FROM ASIWEB.CR_LOCALIZ LOCALIZACAO
ORDER BY LOCALIZACAO.ID_LOCALIZ;


-- CARAGA ESTRUTURA ORGAO / UG (Alterar a sigla e o nome do estrutura orgao 1 para "MARE_MPO")

INSERT INTO public.ESTRUTURAORGAO
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	DATAREFERENCIAVIGENTE,
	ISORGAO,
	NOME,
	SIGLA
)
SELECT
	UG.ID_UG,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	NULL,
	true,
	UG.NM_UG,
	UG.SG_UG
FROM ASIWEB.CR_UG UG
ORDER BY UG.ID_UG;

-- CARGA ESTRUTURA ORGANIZACIONAL / UG

INSERT INTO public.ESTRUTURAORGANIZACIONAL
(
	ID,
	DATAINICIO,
	DATAFIM,
	ALMOXARIFADO,
	CLASSIFICACAO,
	CODIGO,
	POSSUIBEMPATRIMONIAL,
	CONFIGURACAO_ID,
	DOMINIOTIPOESTRUTURAORGANIZACIONAL_ID,
	ESTRUTURAORGANIZACIONALPARENT_ID,
	ESTRUTURAORGANIZACIONALRESPONSAVEL_ID,
	LOCALIZACAO_ID,
	ORGAO_ID
)
SELECT
	UG.ID_UG,
	LOCALTIMESTAMP,
	UG.DT_BLOQUEIO,
	false,
	'',
	UG.CD_UG,
	FALSE,
	NULL,
	(select id from dominio where chave = 'tipoEstruturaOrganizacional' and codigo = 1),
	NULL,
	NULL,
	NULL,
	1
FROM ASIWEB.CR_UG UG
ORDER BY UG.ID_UG;

-- CARAGA ESTRUTURA ORGANIZACIONAL / UA

INSERT INTO public.ESTRUTURAORGAO
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	DATABLOQUEIO,
	VERSION,
	DATAREFERENCIAVIGENTE,
	ISORGAO,
	NOME,
	SIGLA
)
SELECT
	(row_number() OVER (ORDER BY UA.ID_UA)) + 4, -- ADICIONADO 4 QUE É O NUMERO DE UG'S IMPORTADAS
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	UA.DT_BLOQUEIO,
	0,
	NULL,
	false,
	UA.NM_UA,
	UA.SG_UA

FROM ASIWEB.CR_UA UA
ORDER BY UA.ID_UA;

-- CARAGA ESTRUTURA ORGANIZACIONAL / UA

INSERT INTO public.ESTRUTURAORGANIZACIONAL
(
	ID,
	DATAINICIO,
	DATAFIM,
	ALMOXARIFADO,
	CLASSIFICACAO,
	CODIGO,
	POSSUIBEMPATRIMONIAL,
	CONFIGURACAO_ID,
	DOMINIOTIPOESTRUTURAORGANIZACIONAL_ID,
	ESTRUTURAORGANIZACIONALPARENT_ID,
	ESTRUTURAORGANIZACIONALRESPONSAVEL_ID,
	LOCALIZACAO_ID,
	ORGAO_ID
)
SELECT
	(row_number() OVER (ORDER BY UA.ID_UA)) + 4,
	LOCALTIMESTAMP,
	UA.DT_BLOQUEIO,
	false,
	UA.CD_UA_SUP,
	UA.CD_UA,
	FALSE,
	NULL,
	(select id from dominio where chave = 'tipoEstruturaOrganizacional' and codigo = 2),
	(select id from public.estruturaorganizacional where codigo = UA.CD_UG),
	NULL,
	NULL,
	1
FROM ASIWEB.CR_UA UA
ORDER BY UA.ID_UA;

-- CARAGA ESTRUTURA ORGANIZACIONAL / UL

INSERT INTO public.ESTRUTURAORGAO
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	DATABLOQUEIO,
	VERSION,
	DATAREFERENCIAVIGENTE,
	ISORGAO,
	NOME,
	SIGLA
)
SELECT
	(row_number() OVER (ORDER BY UL.ID_UL)) + 463, -- ADICIONADO 4 QUE É O NUMERO DE UG'S IMPORTADAS
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	UL.DT_BLOQUEIO,
	0,
	NULL,
	false,
	(SELECT NOME FROM LOCALIZACAO WHERE CODIGO = UL.CD_LOCAL),
	''

FROM ASIWEB.CR_UL UL
ORDER BY UL.ID_UL;

-- CARAGA ESTRUTURA ORGANIZACIONAL / UL

INSERT INTO public.ESTRUTURAORGANIZACIONAL
(
	ID,
	DATAINICIO,
	DATAFIM,
	ALMOXARIFADO,
	CLASSIFICACAO,
	CODIGO,
	POSSUIBEMPATRIMONIAL,
	CONFIGURACAO_ID,
	DOMINIOTIPOESTRUTURAORGANIZACIONAL_ID,
	ESTRUTURAORGANIZACIONALPARENT_ID,
	ESTRUTURAORGANIZACIONALRESPONSAVEL_ID,
	LOCALIZACAO_ID,
	ORGAO_ID
)
SELECT
	(row_number() OVER (ORDER BY UL.ID_UL)) + 463,
	LOCALTIMESTAMP,
	UL.DT_BLOQUEIO,
	false,
	'',
	UL.CD_UL,
	FALSE,
	NULL,
	(select id from dominio where chave = 'tipoEstruturaOrganizacional' and codigo = 3),
	(select id from public.estruturaorganizacional where codigo = UL.CD_UA),
	NULL,
	(SELECT ID FROM LOCALIZACAO WHERE CODIGO = UL.CD_LOCAL),
	1
FROM ASIWEB.CR_UL UL
ORDER BY UL.ID_UL;

--FAZER SCRIPT PARA SETAR O ID DO LOCAL SUP

--UPDATE public.LOCALIZACAO SET PARENT_ID_ID = (SELECT ID FROM PUBLIC.LOCALIZACAO L WHERE L.CODIGO = CD_LOCAL_SUP::INT = LOCALIZACAO.CODIGO::INT);

-- CRIA AS CLASSE DE PARCEIRO
INSERT INTO public.classeparceiro(id, dominiotipoparceiro_id)
    VALUES (1, (select id from dominio where chave = 'tipoParceiro' and codigo = 1));

INSERT INTO public.classeparceiro(id, dominiotipoparceiro_id)
    VALUES (2, (select id from dominio where chave = 'tipoParceiro' and codigo = 2));

INSERT INTO public.classeparceiro(id, dominiotipoparceiro_id)
    VALUES (3, (select id from dominio where chave = 'tipoParceiro' and codigo = 3));

INSERT INTO public.classeparceiro(id, dominiotipoparceiro_id)
    VALUES (4, (select id from dominio where chave = 'tipoParceiro' and codigo = 4));

INSERT INTO public.classeparceiro(id, dominiotipoparceiro_id)
    VALUES (5, (select id from dominio where chave = 'tipoParceiro' and codigo = 5));

-- CARGA NA TABELA PESSOA FISICA
INSERT INTO public.pessoa
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	NOME,
	EMAIL,
	DOMINIO_PESSOA,
	CODIGO,
	ORGAO_ID
)
SELECT
	AGENTE.ID_AGENTE,
	AGENTE.DT_CADASTRO,
	LOCALTIMESTAMP,
	0,
	AGENTE.NM_AGENTE,
	AGENTE.NM_EMAIL,
	(select id from dominio where chave = 'tipoPessoa' and codigo = 1),
	AGENTE.CD_AGENTE,
	1 -- ORGÃO PADRÃO
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_SIT_JURIDICA = '2'
ORDER BY AGENTE.ID_AGENTE;

-- CARGA NA TABELA PESSOA FISICA
INSERT INTO public.pessoafisica
(
	CPF,
	PESSOA_ID
)
SELECT
	AGENTE.NR_IDENT_AGENTE,
	AGENTE.ID_AGENTE
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_SIT_JURIDICA = '2'
ORDER BY AGENTE.ID_AGENTE;

-- CARGA NA TABELA PESSOA JURIDICA
INSERT INTO public.pessoa
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	NOME,
	EMAIL,
	DOMINIO_PESSOA,
	CODIGO,
	ORGAO_ID
)
SELECT
	AGENTE.ID_AGENTE,
	AGENTE.DT_CADASTRO,
	LOCALTIMESTAMP,
	0,
	AGENTE.NM_AGENTE,
	AGENTE.NM_EMAIL,
	(select id from dominio where chave = 'tipoPessoa' and codigo = 2),
	AGENTE.CD_AGENTE,
	1 -- ORGÃO PADRÃO
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_SIT_JURIDICA = '1'
ORDER BY AGENTE.ID_AGENTE;

-- CARGA NA TABELA PESSOA JURIDICA
INSERT INTO public.pessoajuridica
(
	CNPJ,
	PESSOA_ID
)
SELECT
	AGENTE.NR_IDENT_AGENTE,
	AGENTE.ID_AGENTE
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_SIT_JURIDICA = '1'
ORDER BY AGENTE.ID_AGENTE;


-- CARGA NA TABELA ENDERECO
INSERT INTO public.endereco
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	LOGRADOURO,
	CEP,
	NOME,
	PESSOA_ID
)
SELECT
	(row_number() OVER (ORDER BY AGENTE.ID_AGENTE)) + 47, -- FOI ADICIONADO 47 PQ JA FORAM IMPORTADOS ENDEREÇOS ANTERIORMENTE
	AGENTE.DT_CADASTRO,
	LOCALTIMESTAMP,
	0,
	AGENTE.CD_AGENTE,
	AGENTE.ED_AGENTE,
	AGENTE.NR_CEP,
	AGENTE.NM_BAIRRO,
	AGENTE.ID_AGENTE
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.ED_AGENTE IS NOT NULL
ORDER BY AGENTE.ID_AGENTE;


-- CARGA NA TABELA PARCEIRO DOS FORNECEDORES
INSERT INTO public.parceiro
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	CLASSEPARCEIRO_ID,
	PESSOA_ID
)
SELECT
	AGENTE.ID_AGENTE,
	AGENTE.DT_CADASTRO,
	LOCALTIMESTAMP,
	0,
	AGENTE.CD_AGENTE,
	4, -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
	AGENTE.ID_AGENTE
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_AGENTE = '1'
ORDER BY AGENTE.ID_AGENTE;

-- EXISTEM 1738 AGENTES CADASTRADOS COMO FORNECEDOR, POREM NA TABELA FORNECEDOR SO EXISTE 1736.

-- CARGA NA TABELA FORNECEDOR
INSERT INTO public.fornecedor
(
	ID,
	COMPRASELETRONICAS,
	ESTRANGEIRO
)
SELECT
	AGENTE.ID_AGENTE,
	false,
	false
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_AGENTE = '1'
ORDER BY AGENTE.ID_AGENTE;


-- CARGA NA TABELA PARCEIRO DOS ORGAO EXTERNO
INSERT INTO public.parceiro
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	CLASSEPARCEIRO_ID,
	PESSOA_ID
)
SELECT
	AGENTE.ID_AGENTE,
	AGENTE.DT_CADASTRO,
	LOCALTIMESTAMP,
	0,
	AGENTE.CD_AGENTE,
	2, -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
	AGENTE.ID_AGENTE
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_AGENTE = '4'
ORDER BY AGENTE.ID_AGENTE;

-- CARGA NA TABELA ORGAOEXTERNO
INSERT INTO public.orgaoexterno
(
	ID,
	SIGLA
)
SELECT
	AGENTE.ID_AGENTE,
	''
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_AGENTE = '4'
ORDER BY AGENTE.ID_AGENTE;

-- CARGA NA TABELA PARCEIRO DOS PORTADOR
INSERT INTO public.parceiro
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	CLASSEPARCEIRO_ID,
	PESSOA_ID
)
SELECT
	AGENTE.ID_AGENTE,
	AGENTE.DT_CADASTRO,
	LOCALTIMESTAMP,
	0,
	AGENTE.CD_AGENTE,
	3, -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
	AGENTE.ID_AGENTE
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_AGENTE = '6'
ORDER BY AGENTE.ID_AGENTE;

-- CARGA NA TABELA PORTADOR
INSERT INTO public.parceiro_portador
(
	ID
)
SELECT
	AGENTE.ID_AGENTE
FROM ASIWEB.CR_AGENTE AGENTE
WHERE AGENTE.CD_TP_AGENTE = '6'
ORDER BY AGENTE.ID_AGENTE;



-- FOI SOMADO 468 PARA NÃO DAR PROBLEMA DE MESMA CHAVE, COMO NÃO FOI ENCONTRADO NA BASE DO ASI OS AGENTES DOS FUNCIONARIOS, CORRIGIMOS ISSO NA IMPORTAÇÃO
-- CARGA FUNCIONARIO
INSERT INTO public.pessoa
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	NOME,
	EMAIL,
	DOMINIO_PESSOA,
	CODIGO,
	ORGAO_ID
)
SELECT
	468 + FUNCIONARIO.CD_AGENTE::INT,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	FUNCIONARIO.NM_FUNCIONARIO,
	FUNCIONARIO.NM_EMAIL,
	(select id from dominio where chave = 'tipoPessoa' and codigo = 1), -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
	FUNCIONARIO.CD_AGENTE::INT,
	1
FROM ASIWEB.CR_FUNCIONARIO FUNCIONARIO
ORDER BY FUNCIONARIO.CD_AGENTE::INT;


-- CARGA NA TABELA PARCEIRO DOS COLABORADOR
INSERT INTO public.parceiro
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	CLASSEPARCEIRO_ID,
	PESSOA_ID
)
SELECT
	468 + FUNCIONARIO.CD_AGENTE::INT,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	FUNCIONARIO.CD_AGENTE,
	1,
	468 + FUNCIONARIO.CD_AGENTE::INT
FROM ASIWEB.CR_FUNCIONARIO FUNCIONARIO
ORDER BY FUNCIONARIO.CD_AGENTE::INT;

-- CARGA NA TABELA PORTADOR
INSERT INTO public.parceiro_colaborador
(
	ID,
	CARGO,
	MATRICULA
)
SELECT
	468 + FUNCIONARIO.CD_AGENTE::INT,
	FUNCIONARIO.NM_CARGO,
	FUNCIONARIO.NR_MATRICULA
FROM ASIWEB.CR_FUNCIONARIO FUNCIONARIO
ORDER BY FUNCIONARIO.CD_AGENTE::INT;

--FUNCAO
INSERT INTO funcao(id, datacriacao, dataedicao, version, nome)
  VALUES (500, TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), TO_DATE('2015-01-01 10:26:27','YYYY-MM-DD HH24:MI:SS'), 0, 'GERENTE');

UPDATE parceiro_colaborador SET funcao_id = 500;

-- CARGA ESTRUTURAORGANIZACIONALRESPONSAVEL
INSERT INTO public.ESTRUTURAORGANIZACIONALRESPONSAVEL
(
  DATABLOQUEIO,
  DATAINATIVO,
  DATACRIACAO,
  DATAEDICAO,
  VERSION,
  ORDEM,
  INATIVADOR_ID,
  AUTOR_ID,
  EDITOR_ID,
  ESTRUTURAORGANIZACIONAL_ID,
  FUNCAO_ID,
  RESPONSAVEL_ID
)
SELECT
  NULL,
  dt_fim,
  dt_inicio,
  dt_inicio,
  1,
  NULL,
  NULL,
  NULL,
  NULL,
  (SELECT max(id) FROM public.estruturaorganizacional WHERE codigo = crh.cd_ua),
  (SELECT funcao_id FROM public.PARCEIRO_COLABORADOR WHERE ID = (select pessoa_id from public.parceiro par where par.codigo = (select fun.cd_agente from asiweb.cr_funcionario fun where cd_funcionario = crh.cd_funcionario))  )  ,
  (select pessoa_id from public.parceiro par where par.codigo = (select fun.cd_agente from asiweb.cr_funcionario fun where cd_funcionario = crh.cd_funcionario))
FROM ASIWEB.cr_hierarquia_ua crh;


-- UPDATE ESTRUTURAORGANIZACIONAL PARA COLOCAR A ESTRUTURAORGANIZACIONALRESPONSAVEL
DO $$
DECLARE
  v_eoid  numeric;
  v_eorid numeric;
BEGIN
  FOR v_eoid, v_eorid IN SELECT eo.id eoid, eor.id eorid FROM public.ESTRUTURAORGANIZACIONALRESPONSAVEL eor inner join public.ESTRUTURAORGANIZACIONAL eo on eor.ESTRUTURAORGANIZACIONAL_ID = eo.id
  LOOP
     UPDATE public.ESTRUTURAORGANIZACIONAL SET ESTRUTURAORGANIZACIONALRESPONSAVEL_ID = v_eorid where id = v_eoid;
  END LOOP;
END$$;

-- CARGA CONTA
INSERT INTO public.contacontabil
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	DESCRICAO,
	PERCENTUALNAODEPRECIAVEL,
	TAXADEPRECIACAOMENSAL,
	VIDAUTIL,
	ORGAO_ID,
	DOMINIOTIPOCONTACONTABIL_ID,
	DOMINIOTIPOMATERIAL_ID
)
SELECT
	CONTA.ID_CONTA,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	CONTA.CD_CONTA,
	CONTA.NM_CONTA,
	CONTA.VL_PERCENT_NAO_DEPRECIAVEL,
	0.0,
	COALESCE(CONTA.NR_VIDA_UTIL , 0.0),
	1,
	(select id from dominio where chave = 'tipoContaContabil' and codigo = 5),-- CONTA ATIVA DOMINIO tipoContaContabil
	(select id from dominio where chave = 'tipoMaterial' and codigo = 2)

FROM ASIWEB.CR_CONTA CONTA
WHERE CONTA.CD_SISTEMA = 'PA'
ORDER BY CONTA.ID_CONTA;

-- CARGA CLASSIFICACAO CLASSIFICAÇÃO MATERIAL

INSERT INTO public.classificacaoMaterial
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	DESCRICAO,
	classificacaoMaterialparent_id,
	DOMINIOTIPOCLASSIFICACAOMATERIAL_ID,
	DOMINIOTIPOMATERIAL_ID
)
SELECT
	FEDERAL.ID_BEM_GENERICO,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	FEDERAL.CD_BEM_GENERICO,
	FEDERAL.DS_BEM_GENERICO,
	(SELECT FEDERAL2.ID_BEM_GENERICO FROM ASIWEB.CR_BEM_GENERICO FEDERAL2 WHERE FEDERAL2.CD_BEM_GENERICO = FEDERAL.CD_BEM_GEN_SUP),

	CASE WHEN FEDERAL.CD_GRAU = 0 THEN (select id from dominio where chave = 'tipoClassificacaoMaterial' and codigo = 1)
            WHEN FEDERAL.CD_GRAU = 1 THEN (select id from dominio where chave = 'tipoClassificacaoMaterial' and codigo = 2)
            WHEN FEDERAL.CD_GRAU = 2 THEN (select id from dominio where chave = 'tipoClassificacaoMaterial' and codigo = 3)
            WHEN FEDERAL.CD_GRAU = 3 THEN (select id from dominio where chave = 'tipoClassificacaoMaterial' and codigo = 4)
	END,
	(select id from dominio where chave = 'tipoMaterial' and codigo = 2)
FROM ASIWEB.CR_BEM_GENERICO FEDERAL
WHERE FEDERAL.CD_TIPO_BS = 'P'
ORDER BY FEDERAL.ID_BEM_GENERICO;


-- CARGA CARACTERISTICAS
-- CH - Caracter 	- TEXT_FIELD - 12
-- TX - Texto	- TEXT_AREA  - 13
-- NM - Numérico	- NUMBER     - 14
-- IM - Imagem	- ARQUIVO    - 57

INSERT INTO public.caracteristica
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	DESCRICAO,
	EXPRESSAOREGULAR,
	TAMANHO,
	ORGAO_ID,
	DOMINIOTIPODADO_ID
)
SELECT
	ID_CARACTERISTICA,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	CD_CARACTERISTICA,
	NM_CARACTERISTICA,
	'',
	NR_TAMANHO,
	1,
	(SELECT id FROM public.dominio WHERE chave = 'tipoDado' AND nome = 'TEXT_FIELD')
FROM ASIWEB.CR_CARACTERISTICA
WHERE TP_DADO = 'CH'
UNION ALL
SELECT
	ID_CARACTERISTICA,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	CD_CARACTERISTICA,
	NM_CARACTERISTICA,
	'',
	NR_TAMANHO,
	1,
	(SELECT id FROM public.dominio WHERE chave = 'tipoDado' AND nome = 'TEXT_AREA')
FROM ASIWEB.CR_CARACTERISTICA
WHERE TP_DADO = 'TX'
UNION ALL
SELECT
	ID_CARACTERISTICA,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	CD_CARACTERISTICA,
	NM_CARACTERISTICA,
	'',
	NR_TAMANHO,
	1,
	(SELECT id FROM public.dominio WHERE chave = 'tipoDado' AND nome = 'NUMBER')
FROM ASIWEB.CR_CARACTERISTICA
WHERE TP_DADO = 'NM'
UNION ALL
SELECT
	ID_CARACTERISTICA,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	CD_CARACTERISTICA,
	NM_CARACTERISTICA,
	'',
	NR_TAMANHO,
	1,
	(SELECT id FROM public.dominio WHERE chave = 'tipoDado' AND nome = 'ARQUIVO')
FROM ASIWEB.CR_CARACTERISTICA
WHERE TP_DADO = 'IM';


-- CARGA MATERIAL
INSERT INTO public.MATERIAL
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	DESCRICAO,
	EMPLAQUETAVEL,
	ORGAO_ID,
	CLASSIFICACAOMATERIAL_ID,
	CONTACONTABIL_ID,
	DOMINIOTIPOMATERIAL_ID
)
SELECT
	MATERIAL.ID_BEM_SERVICO,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	MATERIAL.CD_BEM_SERVICO,
	MATERIAL.DS_COMPLETA,
	CASE WHEN MATERIAL.IN_EMPLAQUETAVEL = 'S' THEN true
            WHEN MATERIAL.IN_EMPLAQUETAVEL = 'N' THEN false
        END,
	1,
	(SELECT CLASSIFICACAO.ID FROM public.classificacaoMaterial CLASSIFICACAO WHERE CLASSIFICACAO.CODIGO = MATERIAL.CD_BEM_GENERICO),
	(SELECT CONTA.ID FROM public.contacontabil CONTA WHERE CONTA.CODIGO = MATERIAL.CD_CONTA),
	(select id from dominio where chave = 'tipoMaterial' and codigo = 2)

FROM ASIWEB.CR_BEM_SERVICO MATERIAL
WHERE MATERIAL.CD_BEM_SERVICO LIKE '1%'
ORDER BY MATERIAL.ID_BEM_SERVICO;

ALTER TABLE public.MATERIALPERMANENTE ALTER COLUMN dominiounidademedida_id DROP NOT NULL;

-- CARGA MATERIAL PERMANENTE
INSERT INTO public.MATERIALPERMANENTE
(
	ID_MATERIAL
)
SELECT
	ID
FROM PUBLIC.MATERIAL
ORDER BY PUBLIC.MATERIAL.ID;


-- CARGA CLASSIFICACAO MATERIAL
INSERT INTO public.MaterialCaracteristica
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	GENERICO,
	OBRIGATORIO,
	SEQUENCIA,
	CARACTERISTICA_ID,
	MATERIAL_ID
)
SELECT
	CARACTERISTICA.id_car_bs_possivel,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	CARACTERISTICA.CD_CARACTERISTICA,

	CASE WHEN CARACTERISTICA.IN_CAR_GENERICA = 'S' THEN true
            WHEN CARACTERISTICA.IN_CAR_GENERICA = 'N' THEN false
        END,

	CASE WHEN CARACTERISTICA.IN_OBRIGATORIO = 'S' THEN true
            WHEN CARACTERISTICA.IN_OBRIGATORIO = 'N' THEN false
        END,

	CARACTERISTICA.NR_ORDEM,
	(SELECT CARACTERISTICA2.ID FROM public.CARACTERISTICA CARACTERISTICA2 WHERE CARACTERISTICA2.CODIGO = CARACTERISTICA.CD_CARACTERISTICA),
	(SELECT MATERIAL.ID_BEM_SERVICO FROM ASIWEB.CR_BEM_SERVICO MATERIAL WHERE MATERIAL.CD_BEM_SERVICO = CARACTERISTICA.CD_BEM_SERVICO)
FROM ASIWEB.CR_CAR_BS_POSSIVEL CARACTERISTICA
WHERE CARACTERISTICA.CD_BEM_SERVICO IN (
	SELECT
		MATERIAL.CD_BEM_SERVICO
	FROM ASIWEB.CR_BEM_SERVICO MATERIAL
	WHERE MATERIAL.CD_BEM_SERVICO LIKE '1%'
	ORDER BY MATERIAL.CD_BEM_SERVICO
)
ORDER BY CARACTERISTICA.id_car_bs_possivel;


-- CARGA ENTRADA NÃO DUPLICADAS
INSERT INTO public.entrada
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	DATACONTABIL,
	DATARECEBIMENTO,
	DATAREFERENCIA,
	VALORTOTALNOTA,
	DOMINIOTIPOENTRADA_ID,
	DOMINIOTIPORECEBIMENTO_ID,
	fornecedor_id,
	ORGAO_ID
)
SELECT
	row_number() OVER (ORDER BY ENTRADA.CD_ENTRADA),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	ENTRADA.CD_ENTRADA,
	ENTRADA.DT_CONTABIL,
	ENTRADA.DT_AQUISICAO,
	COALESCE(ENTRADA.DT_CONTABIL, ENTRADA.DT_INCLUSAO),
	(select MAX(ENT.VL_ENTRADA) from ASIWEB.bp_v_entrada ENT
		WHERE ENT.CD_ENTRADA = ENTRADA.CD_ENTRADA
		GROUP BY ENT.CD_ENTRADA),

	(select id from dominio where chave = 'tipoEntrada' and codigo = 1),

        CASE WHEN ENTRADA.CD_TP_FORMA_OP = '01' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 1)
             WHEN ENTRADA.CD_TP_FORMA_OP = '02' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 2)
             WHEN ENTRADA.CD_TP_FORMA_OP = '03' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 3)
             WHEN ENTRADA.CD_TP_FORMA_OP = '04' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 4)
             WHEN ENTRADA.CD_TP_FORMA_OP = '06' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 5)
             WHEN ENTRADA.CD_TP_FORMA_OP = '09' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 6)
             WHEN ENTRADA.CD_TP_FORMA_OP = '31' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 7)
             WHEN ENTRADA.CD_TP_FORMA_OP = '33' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 8)
             WHEN ENTRADA.CD_TP_FORMA_OP = '34' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 9)
             WHEN ENTRADA.CD_TP_FORMA_OP = '37' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 10)
             WHEN ENTRADA.CD_TP_FORMA_OP = '38' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 11)
	END,

	(select parceiro.id from parceiro parceiro where parceiro.codigo = ENTRADA.CD_AGENTE),
	1

FROM ASIWEB.BP_ENTRADA ENTRADA
WHERE ENTRADA.CD_ENTRADA NOT IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
ORDER BY ENTRADA.CD_ENTRADA;


-- CARGA ENTRADAS DUPLICADAS não vou rodar agora porque não consegui passar as nao duplicadas para o entradapatrimonio
/*INSERT INTO public.entrada
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	CODIGOASI,
	DATACONTABIL,
	DATARECEBIMENTO,
	DATAREFERENCIA,
	VALORTOTALNOTA,
	DOMINIOTIPOENTRADA_ID,
	DOMINIOTIPORECEBIMENTO_ID,
	fornecedor_id,
	ORGAO_ID
)
SELECT
	3608 + row_number() OVER (ORDER BY ENTRADA.CD_ENTRADA),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	ENTRADA.CD_ENTRADA,
	ENTRADA.CD_ENTRADA,
	ENTRADA.DT_CONTABIL,
	ENTRADA.DT_AQUISICAO,
	COALESCE(ENTRADA.DT_CONTABIL, ENTRADA.DT_INCLUSAO),
	(select MAX(ENT.VL_ENTRADA) from ASIWEB.bp_v_entrada ENT
		WHERE ENT.CD_ENTRADA = ENTRADA.CD_ENTRADA
		GROUP BY ENT.CD_ENTRADA),
        (select id from dominio where chave = 'tipoEntrada' and codigo = 1),

        CASE WHEN ENTRADA.CD_TP_FORMA_OP = '01' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 1)
             WHEN ENTRADA.CD_TP_FORMA_OP = '02' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 2)
             WHEN ENTRADA.CD_TP_FORMA_OP = '03' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 3)
             WHEN ENTRADA.CD_TP_FORMA_OP = '04' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 4)
             WHEN ENTRADA.CD_TP_FORMA_OP = '06' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 5)
             WHEN ENTRADA.CD_TP_FORMA_OP = '09' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 6)
             WHEN ENTRADA.CD_TP_FORMA_OP = '31' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 7)
             WHEN ENTRADA.CD_TP_FORMA_OP = '33' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 8)
             WHEN ENTRADA.CD_TP_FORMA_OP = '34' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 9)
             WHEN ENTRADA.CD_TP_FORMA_OP = '37' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 10)
             WHEN ENTRADA.CD_TP_FORMA_OP = '38' THEN (select id from dominio where chave = 'tipoRecebimento' and codigo = 11)
	END,
	(select parceiro.id from parceiro parceiro where parceiro.codigo = ENTRADA.CD_AGENTE),
	1

FROM ASIWEB.BP_ENTRADA ENTRADA
WHERE ENTRADA.CD_ENTRADA IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
ORDER BY ENTRADA.CD_ENTRADA;*/


-- CARGA ENTRADA PATRIMONIO
INSERT INTO public.entradapatrimonio
(
	ID,
	DOMINIOTIPOBEM_ID,
	ESTRUTURAORGANIZACIONAL_ID
)
SELECT
	E.ID,
	(select id from dominio where chave = 'tipoBem' and codigo = 1),
	(select min(ID) from PUBLIC.ESTRUTURAORGANIZACIONAL where CODIGO = ENTRADA.CD_UG and (DATAFIM > ENTRADA.DT_INCLUSAO or DATAFIM is null))
FROM PUBLIC.ENTRADA E
INNER JOIN ASIWEB.BP_ENTRADA ENTRADA ON (ENTRADA.CD_ENTRADA = E.CODIGO)
WHERE ENTRADA.CD_ENTRADA NOT IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
AND E.CODIGOASI IS NULL
ORDER BY E.CODIGO;

--COMENTEI PQ TAVA DANDO ID DUPLICADO, VOU DEIXAR PRA DEPOIS
/*INSERT INTO public.entradapatrimonio
(
	ID,
	DOMINIOTIPOBEM_ID,
	ESTRUTURAORGANIZACIONAL_ID
)
SELECT
	E.ID,
	(select id from dominio where chave = 'tipoBem' and codigo = 1),
	(select min(ID) from PUBLIC.ESTRUTURAORGANIZACIONAL where CODIGO = ENTRADA.CD_UG and (DATAFIM > ENTRADA.DT_INCLUSAO or DATAFIM is null))
FROM PUBLIC.ENTRADA E
INNER JOIN ASIWEB.BP_ENTRADA ENTRADA ON (ENTRADA.CD_ENTRADA = E.CODIGO)
WHERE ENTRADA.CD_ENTRADA IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
and E.CODIGOASI IS NOT NULL
ORDER BY E.CODIGO;*/

-- CARGA ENTRADA ITEM DAS ENTRADAS NÃO DUPLICADAS

INSERT INTO public.entradapatrimonioitem
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	EMPLAQUETADO,
	QUANTIDADE,
	VALORUNITARIO,
	ENTRADA_ID,
	MATERIAL_ID_MATERIAL
)
SELECT
	row_number() OVER (ORDER BY BEM.CD_BEM_SERVICO),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	true,
	COUNT(*),
	max(BEM.VL_UNITARIO),
	(select id from public.ENTRADA where codigo = BEM.CD_ENTRADA),
	(select ID from public.MATERIAL where codigo = BEM.CD_BEM_SERVICO)
FROM ASIWEB.BP_BEM BEM
WHERE BEM.CD_ENTRADA NOT IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
GROUP BY BEM.CD_BEM_SERVICO, BEM.CD_ENTRADA
ORDER BY BEM.CD_BEM_SERVICO, BEM.CD_ENTRADA;

--COMENTEI PQ TAVA DANDO ID DUPLICADO, VOU DEIXAR PRA DEPOIS
-- CARGA ENTRADA ITEM DAS ENTRADAS DUPLICADAS
/*INSERT INTO public.entradapatrimonioitem
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	EMPLAQUETADO,
	QUANTIDADE,
	VALORUNITARIO,
	ENTRADA_ID,
	MATERIAL_ID_MATERIAL
)
SELECT
	9407 + row_number() OVER (ORDER BY BEM.CD_BEM_SERVICO),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	true,
	COUNT(*),
	max(BEM.VL_UNITARIO),
	(select ENTRADA.id from public.ENTRADA ENTRADA LEFT JOIN PUBLIC.ENTRADAPATRIMONIO PAT ON (ENTRADA.ID = PAT.ID) LEFT JOIN ESTRUTURAORGANIZACIONAL EST ON EST.ID = PAT.ESTRUTURAORGANIZACIONAL_ID where ENTRADA.codigo = BEM.CD_ENTRADA AND EST.CODIGO = BEM.CD_UG),
	(select ID from public.MATERIAL where codigo = BEM.CD_BEM_SERVICO)
FROM ASIWEB.BP_BEM BEM
WHERE BEM.CD_ENTRADA IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
GROUP BY BEM.CD_BEM_SERVICO, BEM.CD_ENTRADA, BEM.CD_UG
ORDER BY BEM.CD_BEM_SERVICO, BEM.CD_ENTRADA;*/

-- -- CARGA ENTRADA DOCUMENTO DAS ENTRADAS NÃO DUPLICADAS

INSERT INTO public.documento
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	DATAEMISSAO,
	NUMERO,
	DOMINIOTIPODOCUMENTO_ID,
	EMITENTE_ID
)
SELECT
	row_number() OVER (ORDER BY DOC.CD_ENTRADA),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	DOC.DT_EMISSAO,
	DOC.NR_DOCUMENTO,
	CASE WHEN DOC.CD_TP_DOCUMENTO = '001' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 1)
             WHEN DOC.CD_TP_DOCUMENTO = '002' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 2)
             WHEN DOC.CD_TP_DOCUMENTO = '003' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 3)
             WHEN DOC.CD_TP_DOCUMENTO = '006' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 4)
             WHEN DOC.CD_TP_DOCUMENTO = '009' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 5)
             WHEN DOC.CD_TP_DOCUMENTO = '010' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 6)
             WHEN DOC.CD_TP_DOCUMENTO = '014' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 7)
             WHEN DOC.CD_TP_DOCUMENTO = '018' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 8)
	END,
	(select parceiro.id from parceiro parceiro where parceiro.codigo = DOC.CD_AGENTE)
FROM ASIWEB.BP_ENT_DOC DOC
WHERE DOC.CD_ENTRADA NOT IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
ORDER BY DOC.CD_ENTRADA;

INSERT INTO public.entradadocumento
(
	ID,
	ENTRADA_ID
)
SELECT
	row_number() OVER (ORDER BY DOC.CD_ENTRADA),
	(select ENTRADA.id from public.ENTRADA ENTRADA where ENTRADA.codigo = DOC.CD_ENTRADA)
FROM ASIWEB.BP_ENT_DOC DOC
WHERE DOC.CD_ENTRADA NOT IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
ORDER BY DOC.CD_ENTRADA;

-- CARGA ENTRADA DOCUMENTO DAS ENTRADAS DUPLICADAS
/*INSERT INTO public.documento
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	DATAEMISSAO,
	NUMERO,
	DOMINIOTIPODOCUMENTO_ID,
	EMITENTE_ID
)
SELECT
	11048 + row_number() OVER (ORDER BY DOC.CD_ENTRADA),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	DOC.DT_EMISSAO,
	DOC.NR_DOCUMENTO,
	CASE WHEN DOC.CD_TP_DOCUMENTO = '001' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 1)
             WHEN DOC.CD_TP_DOCUMENTO = '002' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 2)
             WHEN DOC.CD_TP_DOCUMENTO = '003' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 3)
             WHEN DOC.CD_TP_DOCUMENTO = '006' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 4)
             WHEN DOC.CD_TP_DOCUMENTO = '009' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 5)
             WHEN DOC.CD_TP_DOCUMENTO = '010' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 6)
             WHEN DOC.CD_TP_DOCUMENTO = '014' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 7)
             WHEN DOC.CD_TP_DOCUMENTO = '018' THEN (select id from dominio where chave = 'tipoDocumento' and codigo = 8)
	END,
	(select parceiro.id from parceiro parceiro where parceiro.codigo = DOC.CD_AGENTE)
FROM ASIWEB.BP_ENT_DOC DOC
WHERE DOC.CD_ENTRADA IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
ORDER BY DOC.CD_ENTRADA;

INSERT INTO public.entradadocumento
(
	ID,
	ENTRADA_ID
)
SELECT
	11048 + row_number() OVER (ORDER BY DOC.CD_ENTRADA),
	(select ENTRADA.id from public.ENTRADA ENTRADA LEFT JOIN ESTRUTURAORGANIZACIONAL EST ON EST.ID = ENTRADA.ESTRUTURAORGANIZACIONAL_ID where ENTRADA.codigo = DOC.CD_ENTRADA AND EST.CODIGO = DOC.CD_UG)
FROM ASIWEB.BP_ENT_DOC DOC
WHERE DOC.CD_ENTRADA IN ('1996000011','1996000067','1998000035','1998000006','1998000016','1995000050','1996000050','1996000053','1995000060','1993000022','1994000020','1995000028','1996000089','1995000031','1994000004','1996000041','1995000019','1996000009','1996000005','1996000024','1998000031','1996000034','1995000070','1996000087','1995000064','1996000003','1995000024','1995000036','1996000035','1994000014','1995000059','1995000017','1996000020','1996000082','1995000010','1996000085','1995000074','1995000061','1996000037','1996000076','1996000083','1994000009','1994000007','1995000067','1998000029','1995000040','1996000033','1996000084','1998000001','1995000072','1995000018','1995000066','1996000019','1998000027','1998000021','1994000013','1996000044','1996000090','1995000030','1998000028','1998000018','1993000027','1996000018','1994000011','1996000086','1996000071','1995000058','1995000038','1998000008','1993000019','1996000064','1996000051','1993000021','1996000080','1996000052','1998000005','1995000008','1995000029','1996000027','1995000042','1996000008','1995000009','1996000013','1998000025','1996000059','1995000002','1995000078','1993000025','1998000003','1995000007','1998000007','1998000013','1995000077','1996000078','1994000012','1996000022','1995000065','1994000018','1995000034','1996000021','1995000051','1996000032','1995000062','1998000002','1994000005','1996000055','1995000075','1996000088','1995000022','1995000035','1993000029','1996000042','1995000063','1998000030','1995000027','1996000043','1995000048','1996000016','1996000091','1993000020','1994000001','1993000024','1995000055','1996000079','1998000014','1995000056','1993000018','1996000030','1995000069','1998000026','1996000002','1998000022','1995000044','1996000023','1996000057','1995000045','1994000003','1996000054','1995000053','1998000024','1995000049','1994000010','1996000038','1996000073','1994000019','1994000016','1996000093','1996000049','1995000076','1995000001','1996000017','1996000048','1998000034','1996000098','1996000006','1996000010','1994000008','1995000003','1996000068','1995000039','1998000032','1996000092','1998000009','1993000023','1996000029','1996000001','1993000017','1996000081','1996000095','1995000014','1996000096','1996000015','1998000033','1996000065','1996000062','1996000058','1995000006','1995000021','1994000017','1995000032','1998000023','1995000015','1995000073','1998000017','1998000004','1995000004','1996000077','1995000068','1996000012','1995000052','1996000094','1995000025','1996000004','1993000026','1995000013','1996000072','1996000014','1995000071','1996000028','1996000040','1995000037','1995000041','1995000016','1995000047','1995000005','1995000054','1995000020','1998000010','1996000097','1995000057','1995000011','1995000079','1995000043','1996000075','1996000047','1996000066','1998000036','1995000033','1996000007','1995000026','1996000036','1998000020','1995000012','1998000019','1994000006','1996000031','1996000025','1996000026','1998000015','1996000061','1995000046','1996000045','1996000070','1996000074','1996000069','1998000011','1996000063','1996000060','1996000056','1996000046','1998000012','1993000028','1996000039')
ORDER BY DOC.CD_ENTRADA;*/


-- CARGA DO BEM

INSERT INTO public.BemPatrimonial
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	BEMPRINCIPAL,
	DATAINICIODEPRECIACAO,
	DATAFINALDEPRECIACAO,
	DATAINICIALGARANTIA,
	DATAFINALGARANTIA,
	NUMEROPATRIMONIAL,
	VALORAQUISICAO,
	valorliquido,
	vidautiloriginal,
    vidautilrestante,
    orgao_id,
    bempatrimonialprincipal_id,
    bempatrimonialvaloranterior_id,
    detentor_id,
    dominiosituacaofisica_id,
    dominiostatus_id,

    estruturaorganizacionalatual_id,
    estruturaorganizacionalcompra_id,
    fornecedor_id,
	material_id_material,
    responsavel_id
)
SELECT
	row_number() OVER (ORDER BY BEM.CD_BEM_PERM),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	BEM.CD_BEM_PERM,
	FALSE,
	NULL,
	NULL,
	BEM.DT_GARANTIA_INI,
	BEM.DT_GARANTIA_FIM,
	BEM.CD_BEM_PERM,
	BEM.VL_UNIT_ENTRADA,
	BEM.VL_UNITARIO,
	BEM.NR_VIDA_UTIL,
	BEM.NR_VIDA_UTIL,
	1,
	NULL,
	NULL,
	NULL,

	CASE     WHEN BEM.CD_TP_SIT_FISICA = '02' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 1)
             WHEN BEM.CD_TP_SIT_FISICA = '03' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 2)
             WHEN BEM.CD_TP_SIT_FISICA = '04' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 3)
             WHEN BEM.CD_TP_SIT_FISICA = '05' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 4)
             WHEN BEM.CD_TP_SIT_FISICA = '06' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 5)
             WHEN BEM.CD_TP_SIT_FISICA = '07' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 6)
             WHEN BEM.CD_TP_SIT_FISICA = '08' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 7)
             WHEN BEM.CD_TP_SIT_FISICA = '09' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 8)
             WHEN BEM.CD_TP_SIT_FISICA = '10' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 9)
             WHEN BEM.CD_TP_SIT_FISICA = '11' THEN (select id from dominio where chave = 'tipoSituacaoFisica' and codigo = 10)
	END,

	CASE 	 WHEN BEM.CD_TP_STATUS = '01' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 1)
             WHEN BEM.CD_TP_STATUS = '02' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 2)
             WHEN BEM.CD_TP_STATUS = '03' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 3)
             WHEN BEM.CD_TP_STATUS = '04' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 4)
             WHEN BEM.CD_TP_STATUS = '05' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 5)
             WHEN BEM.CD_TP_STATUS = '06' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 6)
             WHEN BEM.CD_TP_STATUS = '07' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 7)
             WHEN BEM.CD_TP_STATUS = '08' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 8)
             WHEN BEM.CD_TP_STATUS = '09' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 9)
	END,

	(select id from public.estruturaorganizacional where codigo = BEM.CD_UL_ATUAL),
	(select id from public.estruturaorganizacional where codigo = BEM.CD_UL_ENTRADA),

	(select ENTRADA.fornecedor_id from public.ENTRADA ENTRADA LEFT JOIN PUBLIC.ENTRADAPATRIMONIO PAT ON (ENTRADA.ID = PAT.ID) LEFT JOIN ESTRUTURAORGANIZACIONAL EST ON EST.ID = PAT.ESTRUTURAORGANIZACIONAL_ID where ENTRADA.codigo = BEM.CD_ENTRADA AND EST.CODIGO = BEM.CD_UG),

	(select MAT.ID from public.MATERIAL MAT where MAT.codigo = BEM.CD_BEM_SERVICO),

	NULL
FROM ASIWEB.BP_BEM BEM
ORDER BY BEM.CD_BEM_PERM;

-- CARGA CONTACONTABILMOVIMENTO

-- ADICIONEI O BEM PATRIMONIAL PARA A MIGRACAO, DEPOIS APAGAR
ALTER TABLE public.CONTACONTABILMOVIMENTO ADD COLUMN bempatrimonial_id bigint;

INSERT INTO public.CONTACONTABILMOVIMENTO
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	datareferencia,
        valor,
        contacontabil_id,
        dominiotipomovimentocontacontabil_id,
        baixa_id,
        bempatrimonial_id,
        entrada_id,
        transferenciaconta_id
)
SELECT
	row_number() OVER (ORDER BY BEM.CD_BEM_PERM),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	ENTRADA.DT_INCLUSAO,
	CASE
		WHEN BEM.VL_UNITARIO > 1 THEN BEM.VL_UNITARIO/100::NUMERIC(16,6)
		ELSE BEM.VL_UNITARIO
	END,

	(select ID from public.CONTACONTABIL where codigo = '5292'), -- CONTA ALMOXARIFADO
	(select id from dominio where chave = 'tipoMovimentoContaContabil' and codigo = 1),
	null,
	(SELECT ID FROM PUBLIC.BEMPATRIMONIAL WHERE CODIGO = BEM.CD_BEM_PERM),
	(select ENT.id from public.ENTRADA ENT LEFT JOIN PUBLIC.ENTRADAPATRIMONIO PAT ON (ENT.ID = PAT.ID) LEFT JOIN ESTRUTURAORGANIZACIONAL EST ON EST.ID = PAT.ESTRUTURAORGANIZACIONAL_ID where ENT.codigo = ENTRADA.CD_ENTRADA AND EST.CODIGO = BEM.CD_UG),
	NULL
FROM ASIWEB.BP_BEM BEM
LEFT JOIN ASIWEB.BP_ENTRADA ENTRADA ON ENTRADA.CD_ENTRADA = BEM.CD_ENTRADA
ORDER BY BEM.CD_ENTRADA;

-- CARGA SAIDA TEMPORARIA
INSERT INTO public.saidatemporaria
(
	DATABLOQUEIO,
	DATAINATIVO,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	DATASAIDA,
	PREVISAORETORNO,
	INATIVADOR_ID,
	AUTOR_ID,
	EDITOR_ID,
	ORGAO_ID,
	DESTINO_ID,
	DOMINIOTIPOOBJETIVO_ID,
	DOMINIOTIPOPROJETO_ID,
	ESTRUTURAORGANIZACIONAL_ID,
	PORTADOR_ID,
	RESPONSAVEL_ID
)
SELECT
	NULL,
	NULL,
	CASE WHEN TRANSF.DT_INCLUSAO IS NULL THEN LOCALTIMESTAMP  ELSE TRANSF.DT_INCLUSAO END,
	LOCALTIMESTAMP,
	0,
	CAST(TRANSF.CD_TRANSFERENCIA AS TEXT),
	TRANSF.DT_TRANSFERENCIA,
	TRANSF.DT_PREV_RETORNO,
	NULL,
	NULL,
	NULL,
	1,
	(select pessoa_id from public.parceiro par where par.codigo = TRANSF.CD_FORNEC_ORGEXT),
    CASE WHEN TRANSF.CD_MOTIVO_SAIDA_TEMP = '02' THEN (select id from dominio where chave = 'tipoObjetivoTransferencia' and codigo = 2)
	     WHEN TRANSF.CD_MOTIVO_SAIDA_TEMP = '04' THEN (select id from dominio where chave = 'tipoObjetivoTransferencia' and codigo = 3)
	     WHEN TRANSF.CD_MOTIVO_SAIDA_TEMP = '06' THEN (select id from dominio where chave = 'tipoObjetivoTransferencia' and codigo = 5)
	END,
	NULL,
	(select ID from public.ESTRUTURAORGANIZACIONAL eo where eo.codigo = TRANSF.CD_UG),
	(select pessoa_id from public.parceiro par where par.codigo = TRANSF.CD_PORTADOR),
	(select pessoa_id from public.parceiro par where par.codigo = (select fun.cd_agente from asiweb.cr_funcionario fun where cd_funcionario = TRANSF.CD_FUN_AUTORIZ_SAIDA))
FROM ASIWEB.BP_TRANSF_EXTERNA TRANSF
ORDER BY TRANSF.CD_TRANSFERENCIA;

-- CARGA SAIDA TEMPORARIA ITEM
INSERT INTO public.saidatemporariaitem
(
	databloqueio,
	datainativo,
	datacriacao,
	dataedicao,
	version,
	dataretorno,
	garantiafinal,
	garantiainicial,
	sequencia,
	solucaoconserto,
	valorconserto,
	inativador_id,
	autor_id,
	editor_id,
	bempatrimonial_id,
	dominiostatusanterior_id,
	dominiostatusretorno_id,
	recebedor_id,
	saidatemporaria_id,
	saidatemporariainativo_id
)
SELECT
	NULL,
	NULL,
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	TRANSFBEM.dt_contabil_retorno,
	TRANSFBEM.dt_garantia_fim,
	TRANSFBEM.dt_garantia_ini,
	NULL,
	NULL,
	TRANSFBEM.vl_conserto,
	NULL,
	NULL,
	NULL,
	(select id from public.bempatrimonial bp where bp.codigo = (select fun.cd_bem_perm from asiweb.bp_bem fun where sq_bem_perm = TRANSFBEM.sq_bem_perm)),
	NULL,
	CASE WHEN TRANSFBEM.cd_tp_status_o = '01' THEN (select id from dominio where chave = 'tipoStatusBem' and codigo = 1) END,
	(select pessoa_id from public.parceiro par where par.codigo = (select fun.cd_agente from asiweb.cr_funcionario fun where cd_funcionario = TRANSFBEM.CD_RECEBEDOR)),
	(select id from public.saidatemporaria sai where sai.codigo = TRANSFBEM.CD_TRANSFERENCIA),
	NULL
FROM ASIWEB.BP_TRANSF_EXT_BEM TRANSFBEM
ORDER BY TRANSFBEM.CD_TRANSFERENCIA;

-- CARGA BAIXA
ALTER TABLE public.BAIXA ADD COLUMN codigo bigint;

INSERT INTO public.baixa
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	ORGAO_ID,
	CODIGO
)
SELECT
	row_number() OVER (ORDER BY BAIXA.SQ_BAIXA),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	1,
	BAIXA.SQ_BAIXA
FROM ASIWEB.BP_BAIXA BAIXA where BAIXA.DT_INICIO_BAIXA between '2014-01-01' and LOCALTIMESTAMP
ORDER BY BAIXA.NR_BAIXA;

 --BAIXA SOMENTE DE 2014 PARA CA

INSERT INTO PUBLIC.BAIXAPATRIMONIO
(
	ID,
	CODIGO,
	DATACONTABILIZACAO,
	DATACONCLUSAO,
	DATAINICIO,
	DESTINO_ID,
	PORTADOR_ID,
	DOMINIOSITUACAOBAIXA_ID,
	DOMINIOTIPOBAIXA_ID,
	DOMINIOTIPOBEM_ID
)
SELECT
	B.ID,
	BAIXA.SQ_BAIXA,
	BAIXA.DT_CONTABIL,
	BAIXA.DT_CONTABIL,
	BAIXA.DT_INICIO_BAIXA,
	(select parceiro.id from parceiro parceiro where parceiro.codigo = BAIXA.CD_DESTINO),
	(select parceiro.id from parceiro parceiro where parceiro.codigo = BAIXA.CD_PORTADOR),
        CASE WHEN BAIXA.CD_TP_SIT_BAIXA = '01' THEN (select id from dominio where chave = 'tipoSituacaoBaixa' and codigo = 1)
             WHEN BAIXA.CD_TP_SIT_BAIXA = '02' THEN (select id from dominio where chave = 'tipoSituacaoBaixa' and codigo = 2)
             WHEN BAIXA.CD_TP_SIT_BAIXA = '03' THEN (select id from dominio where chave = 'tipoSituacaoBaixa' and codigo = 3)
	END,
        CASE WHEN BAIXA.CD_TP_FORMA_OP = '14' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 1)
             WHEN BAIXA.CD_TP_FORMA_OP = '15' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 2)
             WHEN BAIXA.CD_TP_FORMA_OP = '16' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 3)
             WHEN BAIXA.CD_TP_FORMA_OP = '17' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 4)
             WHEN BAIXA.CD_TP_FORMA_OP = '18' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 5)
             WHEN BAIXA.CD_TP_FORMA_OP = '19' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 6)
             WHEN BAIXA.CD_TP_FORMA_OP = '20' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 7)
             WHEN BAIXA.CD_TP_FORMA_OP = '23' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 8)
             WHEN BAIXA.CD_TP_FORMA_OP = '25' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 9)
             WHEN BAIXA.CD_TP_FORMA_OP = '26' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 10)
             WHEN BAIXA.CD_TP_FORMA_OP = '27' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 11)
             WHEN BAIXA.CD_TP_FORMA_OP = '28' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 12)
             WHEN BAIXA.CD_TP_FORMA_OP = '29' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 13)
             WHEN BAIXA.CD_TP_FORMA_OP = '30' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 14)
             WHEN BAIXA.CD_TP_FORMA_OP = '36' THEN (select id from dominio where chave = 'tipoBaixa' and codigo = 15)
	END,
	(select id from dominio where chave = 'tipoBem' and codigo = 1)
FROM PUBLIC.BAIXA B
INNER JOIN ASIWEB.BP_BAIXA BAIXA ON (B.CODIGO = BAIXA.SQ_BAIXA) where BAIXA.DT_INICIO_BAIXA between '2014-01-01' and LOCALTIMESTAMP
ORDER BY B.CODIGO;

--BAIXA ITEM
INSERT INTO PUBLIC.BAIXAPATRIMONIOITEM
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	BAIXA_ID,
	BEMPATRIMONIAL_ID,
	DATAESTORNO
)
SELECT
	row_number() OVER (ORDER BY BAIXA_ITEM.SQ_BAIXA, BAIXA_ITEM.SQ_BEM_PERM),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	(select BAIXA.id from public.BAIXA BAIXA where BAIXA.codigo = BAIXA_ITEM.SQ_BAIXA),
	(select BEM.ID from public.BEMPATRIMONIAL BEM where BEM.CODIGO = (SELECT B.CD_BEM_PERM FROM ASIWEB.BP_BEM B WHERE B.SQ_BEM_PERM = BAIXA_ITEM.SQ_BEM_PERM)),
	BAIXA_ITEM.DT_ESTORNO
FROM ASIWEB.BP_BAIXA_ITEM BAIXA_ITEM where BAIXA_ITEM.SQ_BAIXA IN (SELECT CODIGO FROM PUBLIC.BAIXA)
ORDER BY BAIXA_ITEM.SQ_BAIXA, BAIXA_ITEM.SQ_BEM_PERM;


--TRANSFERENCIA LIMITEI O PERIODO DE 2014 ATE HJ PARA NAO LEVAR MT TEMPO PRA RODAR
INSERT INTO public.transferencia
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	CODIGO,
	DATATRANSFERENCIA,
	REFERENCIAVIGENTE,
	ESTRUTURAORGANIZACIONALDESTINO_ID,
	ORGAO_ID
)
SELECT
	row_number() OVER (ORDER BY T.CD_TRANSFERENCIA),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	T.CD_TRANSFERENCIA,
	T.DT_TRANSFERENCIA,
	(CASE WHEN (T.DT_AUTORIZACAO IS NULL) THEN T.DT_TRANSFERENCIA ELSE T.DT_AUTORIZACAO END),
	(select id from PUBLIC.ESTRUTURAORGANIZACIONAL E where E.codigo = T.CD_UL_D),
	1
FROM ASIWEB.BP_TRANSF_INTERNA T WHERE T.DT_TRANSFERENCIA BETWEEN '2014-01-01' AND LOCALTIMESTAMP
ORDER BY T.CD_TRANSFERENCIA;


INSERT INTO public.transferenciaitem
(
	ID,
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	TRANSFERENCIA_ID,
	BEMPATRIMONIAL_ID,
	ESTRUTURAORGANIZACIONALORIGEM_ID
)
SELECT
	row_number() OVER (ORDER BY TI.CD_TRANSFERENCIA),
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	(select id from public.TRANSFERENCIA T where T.codigo = TI.CD_TRANSFERENCIA),
	(select BEM.ID from public.BEMPATRIMONIAL BEM where BEM.CODIGO = (SELECT B.CD_BEM_PERM FROM ASIWEB.BP_BEM B WHERE B.SQ_BEM_PERM = TI.SQ_BEM_PERM)),
	(select ID from public.ESTRUTURAORGANIZACIONAL E where E.CODIGO = (SELECT TR.CD_UL_O FROM ASIWEB.BP_TRANSF_INTERNA TR WHERE TR.CD_TRANSFERENCIA = TI.CD_TRANSFERENCIA))
FROM ASIWEB.BP_TRANSF_INT_BEM TI WHERE TI.CD_TRANSFERENCIA IN (SELECT CODIGO FROM PUBLIC.TRANSFERENCIA)
ORDER BY TI.CD_TRANSFERENCIA;


-- CARGA DOS MOVIMENTOCONTACONTABIL

--Comentei porque faz exatamente a mesma coisa que uma instrucao mais acima

/*INSERT INTO public.CONTACONTABILMOVIMENTO
(
	DATACRIACAO,
	DATAEDICAO,
	VERSION,
	datareferencia,
        valor,
        contacontabil_id,
        dominiotipomovimentocontacontabil_id,
        baixa_id,
        bempatrimonial_id,
        entrada_id,
        transferencia_id
)
SELECT
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	ENTRADA.DT_INCLUSAO,
	CASE
		WHEN BEM.VL_UNITARIO > 1 THEN BEM.VL_UNITARIO/100::NUMERIC(16,6)
		ELSE BEM.VL_UNITARIO
	END,

	(select ID from public.CONTACONTABIL where codigo = '5292'), -- CONTA ALMOXARIFADO
	(select id from dominio where chave = 'tipoMovimentoContaContabil' and codigo = 1),
	null,
	(SELECT ID FROM PUBLIC.BEMPATRIMONIAL WHERE CODIGO = BEM.CD_BEM_PERM),
	(select ENTRADA.id from public.ENTRADA ENTRADA LEFT JOIN ESTRUTURAORGANIZACIONAL EST ON EST.ID = ENTRADA.ESTRUTURAORGANIZACIONAL_ID where ENTRADA.codigo = BEM.CD_ENTRADA AND EST.CODIGO = BEM.CD_UG),
	NULL
FROM ASIWEB.BP_BEM BEM
LEFT JOIN ASIWEB.BP_ENTRADA ENTRADA ON ENTRADA.CD_ENTRADA = BEM.CD_ENTRADA
ORDER BY BEM.CD_ENTRADA;
*/

--Tive que criar a sequencia pq não sei pq nao estava criada

-- REMOVE OS MOVIMENTO DE 2015
delete from contacontabilmovimento mov where EXTRACT(year FROM mov.dataReferencia) = 2015;


CREATE SEQUENCE contacontabilmovimento_id_seq
 INCREMENT 1
 MINVALUE 1
 MAXVALUE 9223372036854775807
 START 189815
 CACHE 1;
ALTER TABLE contacontabilmovimento_id_seq
 OWNER TO postgres;

--ANEXA SEQUENCE NA COLUNA ID DA TABELA CONTACONTABILMOVIMENTO
ALTER TABLE contacontabilmovimento ALTER id SET DEFAULT NEXTVAL('contacontabilmovimento_id_seq');

-- ENTRADA ORCAMENTARIA
INSERT INTO contacontabilmovimento(

            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (

	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    87040.00,
	    153908,
	    18,
	    131,
	    3540,
	    null
    );

INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    5209.10,
	    153908,
	    22,
	    131,
	    3540,
	    null
    );

INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    311084.42,
	    153908,
	    92,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    14199.99,
	    153908,
	    5,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    6020.00,
	    153908,
	    10,
	    131,
	    1,
	    null
    );

	INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2106.85,
	    153908,
	    14,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1547.60,
	    153908,
	    15,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1625757.00,
	    153908,
	    17,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    328.00,
	    153908,
	    20,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    6035.90,
	    153908,
	    21,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    477.81,
	    153908,
	    24,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    187904.00,
	    153908,
	    26,
	    131,
	    1,
	    null
    );


    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2155461.57,
	    153908,
	    28,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2438487.95,
	    153908,
	    92,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2757.12,
	    153908,
	    1,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1431.20,
	    153908,
	    2,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    25455.28,
	    153908,
	    5,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    26.66,
	    153908,
	    13,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    39663.70,
	    153908,
	    14,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    16953.22,
	    153908,
	    15,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2719.98,
	    153908,
	    16,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    213222.54,
	    153908,
	    17,
	    131,
	    1,
	    null
    );

	INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1586.98,
	    153908,
	    18,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    8701.31,
	    153908,
	    22,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    314.77,
	    153908,
	    25,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    798112.60,
	    153908,
	    26,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    3550831.31,
	    153908,
	    28,
	    131,
	    1,
	    null
    );
-- SAIDA
INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -92249.10,
	    153908,
	    28,
	    132,
	    3540,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -2155461.57,
	    153908,
	    28,
	    132,
	    1,
	    null
    );

INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -156.74,
	    153908,
	    22,
	    132,
	    1,
	    null
    );

	INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -3549433.31,
	    153908,
	    28,
	    132,
	    1,
	    null
    );

-- movimentos conta
INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    87040.00,
	    153908,
	    18,
	    131,
	    3540,
	    null
    );

INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    5209.10,
	    153908,
	    22,
	    131,
	    3540,
	    null
    );

INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    311084.42,
	    153908,
	    92,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    14199.99,
	    153908,
	    5,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    6020.00,
	    153908,
	    10,
	    131,
	    1,
	    null
    );

	INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2106.85,
	    153908,
	    14,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1547.60,
	    153908,
	    15,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1625757.00,
	    153908,
	    17,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    328.00,
	    153908,
	    20,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    6035.90,
	    153908,
	    21,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    477.81,
	    153908,
	    24,
	    131,
	    1,
	    null
    );


    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    187904.00,
	    153908,
	    26,
	    131,
	    1,
	    null
    );


    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2155461.57,
	    153908,
	    28,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2438487.95,
	    153908,
	    92,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2757.12,
	    153908,
	    1,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1431.20,
	    153908,
	    2,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    25455.28,
	    153908,
	    5,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    26.66,
	    153908,
	    13,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    39663.70,
	    153908,
	    14,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    16953.22,
	    153908,
	    15,
	    131,
	    1,
	    null
    );

     INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    2719.98,
	    153908,
	    16,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    213222.54,
	    153908,
	    17,
	    131,
	    1,
	    null
    );

	INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1586.98,
	    153908,
	    18,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    8701.31,
	    153908,
	    22,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    314.77,
	    153908,
	    25,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    798112.60,
	    153908,
	    26,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    3550831.31,
	    153908,
	    28,
	    131,
	    1,
	    null
    );
-- SAIDA
INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -92249.10,
	    153908,
	    28,
	    132,
	    3540,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-01-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -2155461.57,
	    153908,
	    28,
	    132,
	    1,
	    null
    );

INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -156.74,
	    153908,
	    22,
	    132,
	    1,
	    null
    );

	INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-02-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -3549433.31,
	    153908,
	    28,
	    132,
	    1,
	    null
    );

INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    4700.00,
	    153908,
	    92,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1562.46,
	    153908,
	    1,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    54562.00,
	    153908,
	    2,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    3870.00,
	    153908,
	    5,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    1199.70,
	    153908,
	    93,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    3675.00,
	    153908,
	    10,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    195231.51,
	    153908,
	    15,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    7359.80,
	    153908,
	    16,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    6222.08,
	    153908,
	    17,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    386.17,
	    153908,
	    18,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    780.00,
	    153908,
	    19,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    47144.40,
	    153908,
	    22,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    101491.68,
	    153908,
	    26,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    426786.80,
	    153908,
	    28,
	    131,
	    1,
	    null
    );

    INSERT INTO contacontabilmovimento(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            bempatrimonial_id,
            contacontabil_id,
            dominiotipomovimentocontacontabil_id,
            entrada_id,
            transferenciaconta_id)
    VALUES (
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    TO_DATE('2014-12-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    0,
	    TO_DATE('2015-03-01 11:16:25','YYYY-MM-DD HH24:MI:SS'),
	    -428184.80,
	    153908,
	    28,
	    132,
	    3540,
	    null
    );

INSERT INTO public.contacontabilconfiguracaoreferencia
(
	datacriacao,
        dataedicao,
        version,
        apresentarelatorioinventario,
        apresentarelatoriomovimentacaobem,
        mesreferencia,
        contacontabil_id
)
SELECT
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	TRUE,
	TRUE,
	TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
	CONTA.ID
FROM CONTACONTABIL CONTA
ORDER BY CONTA.ID;

INSERT INTO public.contacontabilconfiguracaoreferencia
(
	datacriacao,
        dataedicao,
        version,
        apresentarelatorioinventario,
        apresentarelatoriomovimentacaobem,
        mesreferencia,
        contacontabil_id
)
SELECT
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	TRUE,
	TRUE,
	TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
	CONTA.ID
FROM CONTACONTABIL CONTA
ORDER BY CONTA.ID;

INSERT INTO public.contacontabilconfiguracaoreferencia
(
	datacriacao,
        dataedicao,
        version,
        apresentarelatorioinventario,
        apresentarelatoriomovimentacaobem,
        mesreferencia,
        contacontabil_id
)
SELECT
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	TRUE,
	TRUE,
	TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
	CONTA.ID
FROM CONTACONTABIL CONTA
ORDER BY CONTA.ID;

INSERT INTO public.contacontabilconfiguracaoreferencia
(
	datacriacao,
        dataedicao,
        version,
        apresentarelatorioinventario,
        apresentarelatoriomovimentacaobem,
        mesreferencia,
        contacontabil_id
)
SELECT
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	TRUE,
	TRUE,
	TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
	CONTA.ID
FROM CONTACONTABIL CONTA
ORDER BY CONTA.ID;

INSERT INTO public.contacontabilconfiguracaoreferencia
(
	datacriacao,
        dataedicao,
        version,
        apresentarelatorioinventario,
        apresentarelatoriomovimentacaobem,
        mesreferencia,
        contacontabil_id
)
SELECT
	LOCALTIMESTAMP,
	LOCALTIMESTAMP,
	0,
	TRUE,
	TRUE,
	TO_DATE('2015-04-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
	CONTA.ID
FROM CONTACONTABIL CONTA
ORDER BY CONTA.ID;

-- define apenas as contas ativas no asi
UPDATE contacontabilconfiguracaoreferencia set apresentarelatoriomovimentacaobem = false;

UPDATE contacontabilconfiguracaoreferencia set apresentarelatoriomovimentacaobem = true where contacontabil_id in (
select id from contacontabil where codigo in('144100000','5204','5206','5208','5212','5214','5218','5224','5228','5230','5232','5233','5234','5235','5236','5238','5239','5240','5242','5244','5248','5251','5252','5257','5292'));

update estruturaorgao set datareferenciavigente = TO_DATE('2015-05-01 11:16:25','YYYY-MM-DD HH24:MI:SS') where id = 3;

update classificacaomaterial set orgao_id = 3;

INSERT INTO contacontabilsaldo(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            contacontabil_id)
    VALUES (
		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		0,
		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		4466522.22,
		92 -- 144100000 ? SOFTWARES
    );

        INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		93 -- 144100000 - SOFTWARES
        );

       INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		93 -- 144100000 - SOFTWARES
	);
-- saldo das contas
INSERT INTO contacontabilsaldo(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            contacontabil_id)
    VALUES (
		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		0,
		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		4466522.22,
		92 -- 144100000 - SOFTWARES
    );

INSERT INTO contacontabilsaldo(
            datacriacao,
            dataedicao,
            version,
            datareferencia,
            valor,
            contacontabil_id)
    VALUES (
		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		0,
		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
		4466522.22,
		92 -- 144100000 - SOFTWARES
    );
    INSERT INTO contacontabilsaldo(
                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (
    		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		4777606.64,
    		92 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		7216094.59,
    		92 -- 144100000 - SOFTWARES
        );

       INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		7220794.59,
    		92 -- 144100000 - SOFTWARES
    );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		1561938.37,
    		1 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		1561938.37,
    		1 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		1561938.37,
        		1 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		1564695.49,
        		1 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		1566257.95,
        		1 -- 144100000 - SOFTWARES
    );


    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		1303207.46,
    		2 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		1303207.46,
    		2 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		1303207.46,
    		2 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		1304638.66,
        		2 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		1359200.66,
        		2 -- 144100000 - SOFTWARES
    );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		56587.76,
    		3 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		56587.76,
    		3 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		56587.76,
    		3 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		56587.76,
    		3 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		56587.76,
    		3 -- 144100000 - SOFTWARES
    );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		2147462.99,
    		5 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		2147462.99,
    		5 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		2161662.98,
    		5 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		2187118.26,
    		5 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		2190988.26,
    		5 -- 144100000 - SOFTWARES
    );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0.01,
    		6 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0.01,
    		6 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0.01,
    		6 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0.01,
    		6 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0.01,
    		6 -- 144100000 - SOFTWARES
    );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		317665.75,
    		8 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		317665.75,
    		8 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		317665.75,
    		8 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		317665.75,
    		8 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		317665.75,
    		8 -- 144100000 - SOFTWARES
    );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		157848.37,
    		10 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		157848.37,
    		10 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		163868.37,
    		10 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		163868.37,
    		10 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		167543.37,
    		10 -- 144100000 - SOFTWARES
    );


    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		61081.51,
    		12 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		61081.51,
    		12 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		61081.51,
    		12 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		61081.51,
    		12 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		61081.51,
    		12 -- 144100000 - SOFTWARES
    );


    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		295291.70,
    		13 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(

                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (

    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		295291.70,
    		13 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		295291.70,
    		13 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		295318.36,
    		13 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		295318.36,
    		13 -- 144100000 - SOFTWARES
    );

    INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		95844.07,
        		14 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		95844.07,
        		14 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		97950.92,
            		14 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		137614.62,
            		14 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		137614.62,
            		14 -- 144100000 - SOFTWARES
        );


        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		3188341.47,
        		15 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		3188341.47,
        		15 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		3189889.07,
        		15 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		3206842.29,
            		15 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		3402073.80,
            		15 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		206994.80,
        		16 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		206994.80,
        		16 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		206994.80,
        		16 -- 144100000 - SOFTWARE
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		209714.78,
            		16 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		217074.58,
            		16 -- 144100000 - SOFTWARES
        );


        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		33816395.34,
        		17 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		33816395.34,
        		17 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		35442152.34,
        		17 -- 144100000 - SOFTWARE
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		35655374.88,
            		17 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		35661596.96,
            		17 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		322974.51,
        		18 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		410014.51,
        		18 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		410014.51,
        		18 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		411601.49,
            		18 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		411987.66,
            		18 -- 144100000 - SOFTWARES
        );


        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		28413.98,
        		19 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		28413.98,
        		19 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		28413.98,
        		19 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		28413.98,
        		19 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		29193.98,
            		19 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		44684.84,
        		20 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		44684.84,
        		20 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		45012.84,
        		20 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		45012.84,
        		20 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		45012.84,
        		20 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		115126.47,
        		21 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		115126.47,
        		21 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		115126.47,
        		21 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		115126.47,
        		21 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		115126.47,
        		21 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		12532279.20,
        		22 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		12537488.30,
        		22 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		12543524.20,
        		22 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		12552068.77,
        		22 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		12599213.17,
        		22 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		521.65,
    		23 -- 144100000 - SOFTWARES
        );

    INSERT INTO contacontabilsaldo(
                datacriacao,
                dataedicao,
                version,
                datareferencia,
                valor,
                contacontabil_id)
        VALUES (
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		0,
    		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
    		521.65,
    		23 -- 144100000 - SOFTWARES
        );
        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		521.65,
    		23 -- 144100000 - SOFTWARES
            );

            INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		521.65,
    		23 -- 144100000 - SOFTWARES
            );

           INSERT INTO contacontabilsaldo(

                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (

        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		521.65,
    		23 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		28832.87,
        		24 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		28832.87,
        		24 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		29310.68,
        		24 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		29310.68,
        		24 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		29310.68,
        		24 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		152685.52,
        		25 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		152685.52,
        		25 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		152685.52,
        		25 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		153000.29,
        		25 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		153000.29,
        		25 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		7069685.31,
        		26 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		7069685.31,
        		26 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		7257589.31,
        		26 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		8055701.91,
        		26 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		8157193.59,
        		26 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		11980.00,
        		87 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		11980.00,
        		87 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		11980.00,
        		87 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		11980.00,
        		87 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		11980.00,
        		87 -- 144100000 - SOFTWARES
        );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-11-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0.00,
        		28 -- 144100000 - SOFTWARES
            );

        INSERT INTO contacontabilsaldo(
                    datacriacao,
                    dataedicao,
                    version,
                    datareferencia,
                    valor,
                    contacontabil_id)
            VALUES (
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0,
        		TO_DATE('2014-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
        		0.00,
        		28 -- 144100000 - SOFTWARES
            );
            INSERT INTO contacontabilsaldo(
                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-01-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0.00,
        		28 -- 144100000 - SOFTWARES
                );

                INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-02-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		1398.00,
        		28 -- 144100000 - SOFTWARES
                );

               INSERT INTO contacontabilsaldo(

                        datacriacao,
                        dataedicao,
                        version,
                        datareferencia,
                        valor,
                        contacontabil_id)
                VALUES (

            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0,
            		TO_DATE('2015-03-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
            		0.00,
        		28 -- 144100000 - SOFTWARES
    );

--INSERTS na contacontabilmovimentopatrimonio de tudo que esta na contacontabilmovimento para poder deletar o bempatrimonial_id e compatibilizar com o novo modelo do patrimonio
INSERT INTO PUBLIC.CONTACONTABILMOVIMENTOPATRIMONIO
(
	ID,
	BEMPATRIMONIAL_ID,
	TRANSFERENCIA_ID
)
SELECT
	C.ID,
	C.BEMPATRIMONIAL_ID,
	NULL
FROM PUBLIC.CONTACONTABILMOVIMENTO C
ORDER BY C.ID;

update entrada set orgao_id = 3;
update material set orgao_id = 3;
update material set orgao_id = 3;
update localizacao set orgao_id = 3;
update ContaContabil set orgao_id = 3;
update Caracteristica set orgao_id = 3;
update classificacaomaterial set orgao_id = 3;

-- DELETO A COLUNA, POIS SO CRIEI PARA PODER FAZER OS INSERTS NA TABELA CONTACONTABILMOVIMENTOPATRIMONIO
ALTER TABLE public.CONTACONTABILMOVIMENTO DROP COLUMN bempatrimonial_id;


